<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

if (!function_exists('get_instance_aws_s3'))
{
	function get_instance_aws_s3()
	{
		require_once FCPATH . APPPATH . 'third_party/aws/S3.php';

		$s3	= new S3(AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY);

		return $s3;
	}
}

if (!function_exists('upload_to_aws_s3'))
{
	function upload_to_aws_s3($to_folder="", $file_name="", $is_attachments=false)
	{
		if (!defined('USE_AWS_S3') || !USE_AWS_S3 || empty($to_folder) || empty($file_name))
		{
			return true;
		}

// 		$uploadFile	= FCPATH . "/uploads/4/files/79_2dd4ec19ac38e4dcd3b23c5180c7a437.opt";
		$upload_file	= FCPATH . $to_folder . "/" . $file_name;

		$bucket_name	= AWS_BUCKET_NAME;
		if ($is_attachments)
		{
			$bucket_name	= AWS_ATTACHMENT_BUCKET_NAME;
		}

		$s3	= get_instance_aws_s3();

		// Cache control
		$age	= 60 * 60 * 24 * 15;

// 		$s3->listBuckets();
// 		$contents	= $s3->getBucket($bucketName);
// 		$info	= $s3->getObjectInfo($bucketName, baseName($uploadFile));
// 		$s3->deleteObject($bucketName, baseName($uploadFile))
// 		$s3->deleteBucket($bucketName)

		return $s3->putObjectFile($upload_file, $bucket_name, $to_folder . $file_name, S3::ACL_PUBLIC_READ, array(), $age);
	}
}

if (!function_exists('delete_on_aws_s3'))
{
	function delete_on_aws_s3($file_name="", $is_attachments=false)
	{
		if (!defined('USE_AWS_S3') || !USE_AWS_S3 || empty($file_name))
		{
			return true;
		}

		$bucket_name	= AWS_BUCKET_NAME;
		if ($is_attachments)
		{
			$bucket_name	= AWS_ATTACHMENT_BUCKET_NAME;
		}

		$s3	= get_instance_aws_s3();

		return $s3->deleteObject($bucket_name, $file_name);
	}
}

if (!function_exists('get_file_info_aws_s3'))
{
	function get_file_info_aws_s3($file_name="", $is_attachments=false)
	{
		if (!defined('USE_AWS_S3') || !USE_AWS_S3 || empty($file_name))
		{
			return true;
		}

		$bucket_name	= AWS_BUCKET_NAME;
		if ($is_attachments)
		{
			$bucket_name	= AWS_ATTACHMENT_BUCKET_NAME;
		}

		$s3	= get_instance_aws_s3();

		return $s3->getObjectInfo($bucket_name, $file_name);
	}
}
