<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
$CI 			= & get_instance();
$CI->load->helper('addons');

if ( ! function_exists('enquee_message'))
{
	function enquee_message($msg, $type = false,  $data = array())
	{

		$ci 			= & get_instance();
		$is_ajax_req	= $ci->input->is_ajax_request();
		$message_queue	= array();

		if ($is_ajax_req)
		{
			$return = array($type,$msg,$data);
			header('Content-type: application/json');
			if (!$type && $ci->input->get_request_header('Authorization-ot', TRUE)) {
				return false;
			}
			echo json_encode($return);
			exit;
		}

		$message_queue = $ci->session->userdata('ci_message_queue', array());
		
		if ($msg)
		{
			$msg_type	= ($type)?'success':'error';
			$msg_type	= str_replace('error', 'danger', $msg_type);
			$message_queue[strtolower($msg_type)] = array('message' => $msg);
			$ci->session->set_userdata('ci_message_queue',$message_queue);
		}
	}
}

if ( ! function_exists('out_message'))
{
	function out_message()
	{
		// Initialize variables
		$ci 		= & get_instance();
		$contents	= null;
		$lists		= null;
		$messages	= $ci->session->userdata('ci_message_queue', array());
		
		// Build the sorted message list
		if (is_array($messages) && count($messages)) {
			foreach ($messages as $key => $val)
			{
				// Build the return string
				$type = strtolower($key);
				$contents .= PHP_EOL . '<div id="system-message" class="text-center alert alert-' . $type . '">';			
				$contents .= '<button data-dismiss="alert" class="close" type="button">×</button>';
				$contents .= $val['message'];
				$contents .= '</div>';
			}
		}
		
		$ci->session->set_userdata('ci_message_queue',array());
		return $contents;
	}
}

if ( ! function_exists('date_from_format'))
{
	function date_from_format($format, $date)
	{
		if (phpversion() >= 5.3)
		{
			return DateTime::createFromFormat($format, $date);
		}

		$format	= str_replace(array('Y','m','d', 'H', 'i','a'), array('%Y','%m','%d', '%I', '%M', '%p' ), $format);
		$date	= strptime($date, $format);
		$date['tm_year']	+= 1900;
		$date['tm_mday']++;
		$date['tm_mon']++;
		$timestamp	= mktime($date['tm_hour'], $date['tm_min'], $date['tm_sec'], $date['tm_mon'], $date['tm_mday'], $date['tm_year']);

		return new DateTime('@'. $timestamp);
	}
}

if (!function_exists('user_project_role'))
{
	function user_project_role ($project_id, $user_id = 0)
	{
		$CI =& get_instance();
		$user_id = $user_id?$user_id:$CI->ot_user->get('user_id');
		$CI->db->select('pru.user_role, pr.project_id');
		$CI->db->from('project as pr');
		$CI->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		$CI->db->where(array('pr.entity_id' => $CI->ot_app->get('entity_id'), 'pr.project_id' => $project_id, 'pru.user_id' => $user_id));
		$query = $CI->db->get();
		
		$result =  $query->row();
		
		// Administrator Role users can view all details
		if (!is_object($result) && is_admin())
			$result = (object)array('user_role' => 'A');
		
		return $result;
	}
}

if (!function_exists('load_model'))
{
	function load_model ($model_name, $role)
	{
		$CI =& get_instance();
		$CI->load->model($model_name,'',FALSE,$role);

		return true;
	}
}

if (!function_exists('user_role'))
{
	function user_role($user_id = 0)
	{
		$CI =& get_instance();
		$user_id = $user_id?$user_id:$CI->ot_user->get('user_id');
		$CI->db->select('user_role');
		$CI->db->from('entity_users');
		$CI->db->where(array(
			'entity_id'	=> $CI->ot_app->get('entity_id'),
			'user_id'	=> $user_id
		));
		$query	= $CI->db->get();

		$result	= $query->row();

		return $result?$result->user_role:"";
	}
}

if ( ! function_exists('get_role'))
{
	function get_role($role_num = '0')
	{
		if ($role_num > 3)
		{
			return false;
		}

		$roles	= array('M', 'P', 'F', 'A');
		return $roles[$role_num];
	}
}

if ( ! function_exists('is_admin'))
{
	function is_admin($role = '')
	{
		if ($role == '') {
			$ci 			= & get_instance();
			$user = $ci->session->userdata('user');
			
			$role = ($user) ? $user['user_role'] : $role;
		}
		
		if ($role=='A')
		{
			return true;
		}
		
		return false;
	}
}

if ( ! function_exists('is_pmf'))
{
	function is_pmf($role = '')
	{
		if ($role == '') {
			$ci 			= & get_instance();
			$user = $ci->session->userdata('user');
			
			$role = ($user) ? $user['user_role'] : $role;
		}
		
		if ($role=='F')
		{
			return true;
		}
		
		return false;
	}
}

if ( ! function_exists('is_pm'))
{
	function is_pm($role = '')
	{
		if ($role == '') {
			$ci 			= & get_instance();
			$user = $ci->session->userdata('user');
			
			$role = ($user) ? $user['user_role'] : $role;
		}
		
		if ($role=='P')
		{
			return true;
		}
		
		return false;
	}
}

if ( ! function_exists('is_member'))
{
	function is_member($role = '')
	{
		if ($role == '') {
			$ci 			= & get_instance();
			$user = $ci->session->userdata('user');
			
			$role = ($user) ? $user['user_role'] : $role;
		}
		
		if ($role=='M')
		{
			return true;
		}
		
		return false;
	}
}

if ( ! function_exists('stylesheet'))
{
	function stylesheet($cssname, $return = false)
	{
		$content = '<link href="' . base_url() .$cssname . '" rel="stylesheet" type="text/css" />';
		if ($return)
		{
			return $content;
		}
		echo $content . PHP_EOL;
	}
}

if ( ! function_exists('javascript'))
{
	function javascript($scriptname, $return = false)
	{
		$content	= '<script src="' . base_url() . $scriptname . '" type="text/javascript"></script>';
		if ($return)
		{
			return $content;
		}
		echo $content . PHP_EOL;
	}
}

if ( ! function_exists('is_ip'))
{
	function is_ip($ip_addr=0, $ipv6=false)
	{
		if(preg_match("/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/", $ip_addr))
		{
			$parts	= explode(".", $ip_addr);
			foreach($parts as $ip_parts)
			{
				if(intval($ip_parts) > 255 || intval($ip_parts) < 0)
				{
					return false;
				}
			}
			return true;
		}
		return false;
	}
}

if (!function_exists('array_key_index'))
{
	// If key is not empty then the returned array is indexed by the value.
	function array_key_index($data, $key = '', $duplicate = false)
	{
		if (!$data || $key=='')
		{
			return $data;
		}
		$array	= array();
		foreach ($data as $val)
		{
			if ($duplicate)
			{
				$array[$val[$key]][] = $val;
			}
			else
			{
				$array[$val[$key]] = $val;
			}
		}
		return $array;
	}
}

if (!function_exists('time_in_12_hour_format'))
{
	function time_in_12_hour_format ($time, $seconds=false)
	{
		if (!$seconds)
			return DATE("h:i A", STRTOTIME($time));
		else
			return DATE("h:i:s A", STRTOTIME($time));
	}
}

if (!function_exists('time_in_24_hour_format'))
{
	function time_in_24_hour_format ($time, $seconds=false)
	{
		if (!$seconds)
			return DATE("H:i", STRTOTIME($time));
		else
			return DATE("H:i:s", STRTOTIME($time));
	}
}

if (!function_exists('activity_log'))
{
	function activity_log ($a_mode , $a_id, $a_notes)
	{
		 $CI =& get_instance();

		$data = array('user_id' => $CI->ot_user->get('user_id'), 'entity_id' => $CI->ot_app->get('entity_id'), 'a_date' => $CI->auth->get_timezone_date(), 'user_ip' => $_SERVER['REMOTE_ADDR'], 'a_mode' => $a_mode, 'a_id' => $a_id, 'a_notes' => $a_notes);
		$CI->db->insert('user_activity', $data);
		
		return true;
	}
}
if (!function_exists('get_currency'))
{
	function get_currency($currency_code) 
	{
		$CI =& get_instance();
		$CI->db->select('currency_symbol');
		$CI->db->from('currency');
		$CI->db->where('currency_code', $currency_code);
		$query = $CI->db->get();
		$result = $query->row_array();
		return isset($result['currency_symbol'])?$result['currency_symbol']:'';	
	}
}
if (!function_exists('invoice_activity'))
{
 function invoice_activity($act_data)
    {
    	$CI =& get_instance();
    	$data = array(
				'entity_id' 	=> $CI->ot_app->get('entity_id'),
				'user_id'		=> $CI->ot_user->get('user_id'),
				'a_date'		=> $CI->auth->get_timezone_date(),
				'user_ip'		=> $_SERVER['REMOTE_ADDR']
			);
		$data = array_merge($data, $act_data);
		
		if (!$CI->db->insert('finance_activity', $data))
		{
			return false;
		}
		activity_log($data['a_mode'],$data['invoice_id'], $data['a_notes']);
		return true;
    }
}

if (!function_exists('profile_image_paths'))
{
	function profile_image_paths($size='')
	{
		$CI =& get_instance();
		$return	= array();
		$img_path			=	FCPATH . "uploads/" . $CI->ot_app->get('entity_id') . '/';

		$return['img_path']	= $img_path;
		$return['prof']	= $img_path . 'prof/';
		// Original
		$return['O']	= $img_path . 'prof/O/';
		// Thumbnail
		$return['T']	= array(
			'path'	=> $img_path . 'prof/38/',
			'size'	=> 38
		);
		// Medium
		$return['M']	= array(
			'path'	=> $img_path . 'prof/120/',
			'size'	=> 120
		);
		// Large
		$return['L']	= array(
			'path'	=> $img_path . 'prof/200/',
			'size'	=> 200
		);

		if (!empty($return[$size]))
			return $return[$size];

		return $return;
	}
}

// Socket based notification.
if (!function_exists('send_to_sock_server'))
{
	function send_to_sock_server($msg=array())
	{
		$address		= NOTIFY_ADDRESS;
		$service_port	= NOTIFY_PORT;

		try {
			$socket	= socket_create(AF_INET, SOCK_STREAM, SOL_TCP);

			if ($socket === false) {
// 				throw new Exception('Socket Create Error : ' . socket_strerror(socket_last_error($socket)));
				return false;
			}

			if (socket_connect($socket, $address, $service_port) === false) {
// 				throw new Exception('Socket Connect Error : ' . socket_strerror(socket_last_error($socket)));
				return false;
			}

			$msg	= json_encode($msg);

			if (socket_write($socket, $msg, strlen($msg)) === false) {
// 				throw new Exception('Socket Write Error : ' . socket_strerror(socket_last_error($socket)));
				return false;
			}

			socket_close($socket);
		} catch(Exception $e) {
// 			throw new Exception("Error : " . $e->getMessage());
			return false;
		}

		return true;
	}
}
if (!function_exists('send_to_gearman_server'))
{
	function send_to_gearman_server($msg=array())
	{
		static $client;

		if (!class_exists('GearmanClient'))
		{
			if (!$client)
			{
				$client	= new GearmanClient();
				$client->addServer();
			}

			$client->addTaskBackground($msg['method'], $msg['data']);
			if (!$client->runTasks())
			{
				echo "ERROR " . $client->error() . "\n";
				exit;
			}
		}
	}
}

if (!function_exists('set_background_process'))
{
	function run_background_process($function, $data = array())
	{
// 		send_to_gearman_server(array(
// 			'method'	=> $function,
// 			'data'		=> $data
// 		));

// 		if (function_exists('socket_create'))
		if (extension_loaded('sockets'))
		{
			send_to_sock_server(array(
				'method'	=> $function,
				'data'		=> $data
			));
		}

// 		if (function_exists($function)) {
// 			$function($data);
// 		}
	}
}

if (!function_exists('license_limit'))
{
	function license_limit($id = 0, $type='projects') {
		$ci 			= & get_instance();

		$entity = $ci->session->userdata('entity');
		// if pro plan validate only users
		if ($entity &&  $entity->plan=='P' && $type!='users') {
			return true;
		}

		if ($entity && $entity->plan!='T' && $limit = $entity->max_users)
		{
			$where = array('entity_id' => $entity->entity_id, 'is_active'=>1);
			switch($type) {
				case 'projects':
					$pr_key = 'project_id';
					$tbl = 'project';
				break;
				case 'clients':
					$pr_key = 'client_id';
					$tbl = 'client';
				break;
				case 'users':
					$pr_key = 'user_id';
					$tbl = 'entity_users';
				break;
				default:
					return false;
				break;
			}
			if ($id) {
				$where[$pr_key.' !='] = $id;
			}
			$query = $ci->db->select('count(*) as count')->from($tbl)->where($where)->get();
			$row = $query->row();

			if ($row->count >= $limit) {
				return false;
			}
		}

		return true;
		
	}
}

if (!function_exists('set_cache_header'))
{
	function set_cache_header()
	{
		// 1 min	- 1,
		// 2 hr		- 7200,
		// 1 day	- 86400,
		// 7 days	- 604800,
		// 15 days	- 1296000,
		// 30 days	- 2592000

		header('Cache-Control: max-age=2592000, public');
	}
}

if (!function_exists('show_ot_message'))
{
	function show_ot_message($heading='', $message='')
	{
		ob_start();
		include(APPPATH . 'errors/info.php');
		$buffer = ob_get_contents();
		ob_end_clean();
		echo $buffer;
	}
}

if (!function_exists('number_to_time')) {
	function number_to_time ($number=0) {
		$hrs = floor($number);
		$min	= round((($number - floor($number))/100)*6000);
		if ($min <10) $min = '0'.$min;
		return $hrs.':'.$min;
	}
}
