<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Expense_table extends Base_table {

	function __construct()
	{
        parent::__construct(array('tbl'=>'project_expense', 'tbl_key'=>'expense_id'));
	}
	
	public function formatdata(&$data) 
	{
		$data['unit_price'] = isset($data['unit_price'])?($data['unit_price']-0):0;
		$data['amount'] 	= ($data['unit_price'])?($data['quantity'] * $data['unit_price']):$data['amount'];		
        return true;
    }
    
	public function save($data)
	{
		$result = array();
		$values = $data;
		
		if ($expense_id = parent::save($values)) 
		{
			$result['expense_id'] = $expense_id;
			
			if (empty($data['attachment_delete']) && !empty($data['attach_details']) && !empty($data['attach_details']['file_name']))
			{
				$data['attach_details']['module_type']		= 'E';
	        	$data['attach_details']['module_id']		= $expense_id;
	        	//$data['attach_details']['file_path']		= '';	
				$this->CI->load->library('attachment_table');
				$result['attachment_id'] = $this->CI->attachment_table->save($data['attach_details']);
			} 
			
			if(!empty($data['attachment_delete'])) {
				$this->CI->load->model('attachment');
				$attachment = $this->CI->attachment->delete_attachment(array('module_type' => 'E', 'module_id' => $expense_id));
			}
		}
		
		return $result;
	}
}
/* end of project_expense_table.php */
