<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Project_task_types_table extends Base_table {

	function __construct()
	{
		parent::__construct(array('tbl'=>'project_task_types', 'tbl_key'=>'project_task_type_id'));
    }
	
	public function formatdata(&$data)
	{
		if (empty($data['is_billable']))
		{
			$data['is_billable'] = empty($data['hourly_rate'])?0:1;
		}
        return true;
    }
    
	public function save($data)
	{
		$result = array();
		
		if ($this->check_duplicate($data, array('project_id' => $data['project_id'],'task_type_id' => $data['task_type_id'])))
		{
			$this->CI->response->error('DUPLICATE_TASK_TYPE');
			return false;
		}
		
		if (!$project_task_type_id = parent::save($data))
		{
				return false;
		}
    	
        return $project_task_type_id;
	}
	
	// delete project task types
	public function delete($project_id, $ids=0)
	{
		if ($ids)
		{
			$ids = is_array($ids)?$ids:array($ids);
			$this->CI->db->where_in($this->tbl_key, $ids);
		}
		
		//delete client
		$this->CI->db->where('project_id', $project_id);
		$this->CI->db->where('actual_hours <= 0');
	    $this->CI->db->delete($this->tbl);

	    return ($ids)?$ids:true;
	}
	
	public function store_default_data ($project_id)
	{
		$query	 =  'INSERT INTO '.$this->CI->db->dbprefix('project_task_types')
					.' (task_type_id,is_billable,hourly_rate,project_id,created_by,created_date)'
					.' SELECT task_type_id,is_billable,hourly_rate, '.$project_id .' AS project_id, '
					.$this->user_id.' AS created_by, "'.$this->cur_time.'" AS created_date FROM '.$this->CI->db->dbprefix('task_type')
					.' WHERE entity_id='.$this->entity_id.' AND is_common=1';
		$this->CI->db->query($query,false);
		
		return true;
	}
}
/* end of project_task_types_table.php */
