<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Expenses_member extends CI_Model{

	public $error	= '';

	function __construct()
	{
		parent::__construct();
	}
	
	// 	Magic function return false
	public function __call($name, $arguments)
    {
       $this->response->error('INVALID_REQUEST', true);
       return array();
    } 
	public function expenses_list_query($select='', $options=array())
	{
		$this->db->select($select, false);
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id AND pr.project_id=pru.project_id', 'INNER');
		$this->db->join('project_expense as ex', 'pr.entity_id=ex.entity_id AND pr.project_id=ex.project_id', 'INNER');
		$this->db->join('expense_type as ext', 'ex.entity_id=ext.entity_id AND ex.expense_type_id=ext.expense_type_id', 'LEFT');
		$this->db->join('entity_users u', 'u.entity_id=ext.entity_id AND u.user_id=ex.created_by', 'INNER');

		$where	= array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pru.user_id'=>$this->ot_user->get('user_id'));
		if (!empty($options['filters']))
		{
			foreach($options['filters'] as $key=>$val) {
				if (is_array($val))
					$this->db->where_in($key,$val);
				else
					$where[$key] = $val;
			}
		}
		
		if (isset($options['start_date']))
		{
			$month_dates['start_date']	= $options['start_date'];
			if (isset($options['finish_date']))
				$month_dates['end_date']	= $options['finish_date']; 	
		} else {
			$month_dates = $this->get_start_end_dates(!empty($options['expense_month'])?$options['expense_month']:'');
		}

		$this->db->where($where);
		if (!isset($month_dates['end_date'])) {
			$this->db->where('ex.expense_date',$month_dates['start_date'],NULL,FALSE);
		}
		else {
			$this->db->where('ex.expense_date BETWEEN "' .$month_dates['start_date']. '" AND "' . $month_dates['end_date'] . '"', NULL, FALSE);
		}
		
		if(!empty($options['role_filter'])) {
			$this->db->where($options['role_filter'],NULL, FALSE);
		}

		$order_by 			= 'ex.expense_date';
		$order_by_direction = 'desc';

		$this->db->order_by($order_by, $order_by_direction);

		return $this->db->get();
	}
	
	public function get_expenses($select='', $options=array()) 
	{
		$select	= empty($select) ? 'ex.expense_id, ex.project_id, ex.amount, DATE_FORMAT(ex.expense_date, "%Y-%m-%d") as expense_date, ex.created_by, ex.notes, ex.expense_type_id, ex.approved_by, ex.invoice_id, ex.quantity, ex.unit_price, pr.project_id, pr.project_name, pr.project_code,  u.first_name, u.user_image, ext.name, ext.units' : $select;
		if (empty($options))
		{
			$options	= array_merge($options, $this->options);
		}
		
		//$options['filters']['ex.approved_by >'] = '0';
		$options['role_filter']	= ' ex.created_by= ' . $this->ot_user->get('user_id') . ' and (ex.approved_by>0 or ex.approved_by=0) ';

		$query = $this->expenses_list_query($select, $options);

		$result = $query->result_array();
		
		foreach($result as $key=>$res) 
		{
			$result[$key]['edit_permission'] 		= 1;
			if($res['approved_by']>0)
			{
				$result[$key]['edit_permission'] 	= 0;
			}
		}
		return $result;
	}
	
	public function save ($data)
	{
		$this->load->library('expense_table');
		$data['approved_by'] = 0;
		return $this->expense_table->save($data);		
	}

	public function get_start_end_dates($exp_date='')
	{
		if(!empty($exp_date)) {
			$exp_date = $exp_date;
			$exp = explode(' ', $exp_date);
			$monthNo = array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
			$month_number = array_search($exp[0], $monthNo);
			$start_date = date('Y-m-d', mktime(0, 0, 0, ($month_number+1), 1, $exp[1]));
			$end_date = date('Y-m-t', mktime(0, 0, 0, ($month_number+1), 1, $exp[1]));
		}
		else {
			$start_date = date("Y-m-d", strtotime(date('m').'/01/'.date('Y')));
			$end_date	= date("Y-m-d", strtotime('-1 second',strtotime('+1 month',strtotime(date('m').'/01/'.date('Y')))));
		}
		
		$dates['start_date'] = $start_date;
		$dates['end_date']	 = $end_date;
		
		return $dates;
	}

	public function get_categories()
	{
		$this->db->select('expense_type_id, name, unit_price, units');
		$this->db->from('expense_type e');
		$this->db->where('e.entity_id', $this->ot_app->get('entity_id'));

		$query = $this->db->get();
		$result = $query->result_array(); 
		return $result;
	}

	public function delete ($id)
	{
		$where = array('expense_id ' => $id, 'created_by' => $this->ot_user->get('user_id'), 'entity_id'=>$this->ot_app->get('entity_id'));
		$this->db->where($where);
		if ($this->db->delete('project_expense') &&  $this->db->affected_rows())
		{
			$where = array('entity_id'=>$this->ot_app->get('entity_id'), 'module_type' => 'E','module_id ' => $id);
			$this->db->where($where);
			$this->db->delete('attachment');
			
			return true;
		}

		return false;
	}	
}
