<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/project/mod.project_pmf.php');

class Project_admin extends Project_pmf
{
	function __construct()
	{
		parent::__construct();
	}

	public function get_project($project_id)
	{
		$this->db->select('pr.project_id, cl.client_id, concat(cl.client_code,cl.client_name) as client_name, pr.project_name, pr.description, pr.is_active, pr.project_code, pr.actual_value, pr.budget_value, pr.budget_type, pr.budget_alert_percent, pr.invoice_type, pr.hourly_rate, pr.members_count', false);
		$this->db->from('project as pr');
		$this->db->join('client as cl', 'pr.entity_id=cl.entity_id and pr.client_id = cl.client_id', 'INNER');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pr.project_id' => $project_id));
		$query = $this->db->get();
		
		return $query->result();
	}
	
	public function delete($project_id)
	{
		$this->load->library('project_table');
		$this->project_table->delete($project_id);
		return true;
	}

	public function get_project_task_types($project_ids, $select = '')
	{
		
		if (!is_array($project_ids)) {
			$project_ids = array($project_ids);
		}
		
		$select = ($select!='')?$select:'pty.estimated_hours, pty.hourly_rate, pty.task_type_id, pty.project_task_type_id, pty.actual_hours';
		$this->db->select($select, false);
		$this->db->from('project_task_types as pty');
		$this->db->join('task_type as ty', 'pty.entity_id=ty.entity_id and pty.task_type_id=ty.task_type_id', 'INNER');
	//	$this->db->join('time_sheet AS ts', 'pty.entity_id=ts.entity_id and pty.task_type_id = ts.task_type_id AND pty.project_id = ts.project_id', 'left');
		$this->db->where(array('ty.entity_id' => $this->ot_app->get('entity_id')));
		$this->db->where_in('pty.project_id', $project_ids);
		$this->db->group_by('pty.project_task_type_id');
		$this->db->order_by('ty.sort_order');
		
		$query = $this->db->get();
		return $query->result_array();
	}
	

	public function get_user_roles($pro_users = false)
	{
		$return	= $this->config->config['user_role'];
		if (!$pro_users)
			unset($return['A']);

		return $return;
	}

	public function get_project_attachments($project_id)
	{
		$this->db->select('a.file_type, a.file_name, a.file_path, a.file_size, a.created_by, a.created_date');
		$this->db->from('project as pr');
		$this->db->join('attachment as a', 'pr.entity_id=a.entity_id and pr.project_id=a.module_id and a.module_type="P"', 'INNER');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pr.project_id' => $project_id));
		$this->db->order_by('a.created_by', 'desc');
		
		$query = $this->db->get();
		return $query->result_array();
	}
	
	public function get_project_budget_details($project_id)
	{
		$this->db->select('pr.budget_value, pr.budget_type,pr.budget_alert_percent');
		$this->db->from('project as pr');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pr.project_id' => $project_id));
		
		$query = $this->db->get();
		return $query->result_array();
	}
	
	public function get_project_invoice_details($project_id)
	{
		$result  = array();
		
		$this->db->select('sum(tm.hours * (tm.invoice_id/tm.invoice_id)) as invoiced_hours, sum(tm.hours * !tm.invoice_id) as uninvoiced_hours', false);
		$this->db->from('time_sheet AS tm');
		$this->db->join('project AS pr', 'tm.entity_id=pr.entity_id and tm.project_id = pr.project_id');
// 		$where = array('tm.entity_id' => $this->ot_app->get('entity_id'), 'tm.project_id' => $project_id,  'tm.is_billable' => 1);
		$where = array('tm.entity_id' => $this->ot_app->get('entity_id'), 'tm.project_id' => $project_id);
		$this->db->where($where);
		$query = $this->db->get();
		// echo $this->db->last_query();exit;
		$result = $query->row_array();
		
		$result = array_merge($result,$this->get_total($project_id));
		
		return $result;
	}
	function get_total ($project_id)
	{
		$this->db->select('count(expense_id) as expenses_count, sum(amount) as expenses_amount');
		$this->db->from('project_expense AS pe');
		
		$where = array('pe.entity_id' => $this->ot_app->get('entity_id'), 'pe.project_id' => $project_id);
		$this->db->where($where);
		$query = $this->db->get();
		$row = $query->row_array(); 
		
		return $row;
	}
}
