<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Timesheets_member extends CI_Model {
	public $error	= '';

	function __construct()
	{
		parent::__construct();
		$this->load->library(OTBASE_PATH.'OT_App');
        $this->load->library(OTBASE_PATH.'OT_User');
	}

	// Magic function return false
	public function __call($name, $arguments)
	{
		$this->response->error("PERMISSION_DENIED", 404);
		$this->response->write();
		return false;

// 		$this->response->error('INVALID_REQUEST', true);
// 		return array();
	}
	
	/*function closed_status()
	{
		$this->db->select('task_status_id');
		$this->db->from('task_status');
		$this->db->where(array(
			'entity_id'			=> $this->ot_app->get('entity_id'),
			'system_defined'	=> 1,
			'is_closed'			=> 1
		));
		$query	= $this->db->get();
		return $query->row_array(); 
	}*/

	public function get_tasks($project_id=0, $task_type_id=0, $term='',$limit=10)
	{
		// get closed task status id
		// $result = $this->closed_status();

		$this->db->select('pt.task_id, pt.task_number, pt.task_priority,pt.name, pt.is_billable,pt.task_type_id');
		$this->db->from('project_task AS pt');
//		$this->db->join('project_users AS pru', 'pt.entity_id=pru.entity_id AND pt.project_id=pru.project_id', 'INNER');
		$this->db->join('project_task_users AS ptu', 'pt.entity_id=ptu.entity_id AND pt.task_id=ptu.task_id', 'INNER');

		$where = array(
			'pt.entity_id'		=> $this->ot_app->get('entity_id'),
			'ptu.user_id'		=> $this->ot_user->get('user_id'),
//			'pru.user_id'		=> $this->ot_user->get('user_id'),
			'pt.is_parent'		=> 0,
			/*'pt.task_status_id !=' => $result['task_status_id']*/
			'pt.is_closed !=' => 1
		);

		if (!empty($project_id))
		{
			$where['pt.project_id'] =  $project_id;
		}
		if (!empty($task_type_id))
		{
			//$where['pt.task_type_id'] =  $task_type_id;
			$this->db->where('(pt.task_type_id = '.$task_type_id.' OR pt.task_type_id = "")');
		}

		preg_match('/^#(\d+)*/', $term, $matches);
		if (count($matches) >= 2)
		{
			$where['pt.task_number'] =  $matches[1];
		}
		else
		{
			$this->db->like('pt.name', $term);
			$this->db->order_by('pt.name');
			if ($limit)
				$this->db->limit($limit);
		}

		$this->db->where($where);

		$query = $this->db->get();

		return $query->result_array();
	}

	// return timesheet query
	public function list_query($select, $options = array(), $all = false, $raw_query=false)
	{
		$select .=',if(t.hours,1,0) AS p_hours';
		$this->db->select($select, false);
		$this->db->from('time_sheet AS t');
		$this->db->join('project AS pr',  't.entity_id = pr.entity_id and t.project_id = pr.project_id', 'INNER');
		$this->db->join('project_task AS pt', 't.entity_id = pt.entity_id and t.project_id=pt.project_id and t.project_task_id = pt.task_id', 'LEFT');
		$this->db->join('task_type AS ty', 't.entity_id = ty.entity_id and t.task_type_id=ty.task_type_id', 'LEFT');
		$this->db->join('project_users AS pu', 'pr.entity_id = pu.entity_id and pr.project_id = pu.project_id AND t.user_id=pu.user_id', 'LEFT');
		
		$where	= array('t.entity_id' => $this->ot_app->get('entity_id'));

		if (!$all)
		{
			$where['t.user_id'] = $this->ot_user->get('user_id');
		}

		if (!empty($options['filters']))
		{
			$where = array_merge($where, $options['filters']);
		}
		$this->db->where($where);
		
		if (!empty($options['where_str']))
		{
			$this->db->where($options['where_str'], NULL, FALSE);
		}
		
		if (!empty($options['group_by']))
		{
			$this->db->group_by($options['group_by']);
		}
		if (!$raw_query) {
			$order_by ='p_hours desc, ';
			$order_by .= !empty($options['order_by'])?$options['order_by']:'t.time_sheet_id';
			$order_by_direction = !empty($options['order_by_direction'])?$options['order_by_direction']:'desc';
			if ($order_by && $order_by_direction)
				$this->db->order_by($order_by,$order_by_direction);
		
			$from = !empty($options['from'])?$options['from']:0;
			if (!empty($options['count']))
			{
				$this->db->limit($options['count'], $from);
			}
		}
		return $this->db->get();
	}

	
	public function assigned_tasks ($data, $all=false, $raw_query = false)
	{
		// get closed task status id
		//$result = $this->closed_status();

		if (!empty($data['start_date']) && !empty($data['end_date']))
		{
			$data['date']	= $this->auth->get_timezone_date('Y-m-d');
		}

		$where	= array(
			'pt.entity_id'	=> $this->ot_app->get('entity_id'),
			'pt.assignee_id'	=> !empty($data['user_id'])?$data['user_id']:$this->ot_user->get('user_id'),
			'is_parent'		=> 0,
			'pt.is_closed !='	=> 1
		);
	
		if (!empty($data['date'])) {
			$where["DATE_FORMAT(pt.start_date, '%Y-%m-%d') <= "]	= $data['date'];
		}

		/*if ($result)
		{
			$where['pt.task_status_id !=']	= $result['task_status_id'];
		}*/

		$select  = ' 0 AS time_sheet_id, pr.project_id, pt.task_type_id, pt.task_id AS project_task_id, pt.task_number, pt.task_priority, "' . $data['date'] . '" AS entry_date, 0 as hours, "" AS notes, 0 AS is_progress, "" AS approval_status, 0 AS is_billable, 0 AS invoice_id,  pr.project_code, pr.project_name, pr.bg_color, pt.name AS activity_name, ty.name, pu.user_role, 0 AS estimated_hours, "'.$this->ot_user->get('user_id') .'" AS approved_by, pt.last_updated_date, 0 AS p_hours';

		if (!$raw_query) {
			if($all)
			{
				$select	= 'pt.assignee_id , ty.name AS task_type, concat(pr.project_code, pr.project_name) as project_name,';
				unset($where['pt.assignee_id']);
			}
			else
				$select	= 'ty.name,pr.project_name,';

			$select.=' pr.project_id, pt.task_type_id, pt.task_number, pt.task_priority, pt.task_id AS project_task_id, pt.is_billable,pr.bg_color,  pr.project_code, pt.name AS activity_name, pu.user_role, 0 as hours, "' . $data['date'] . '" AS entry_date';
		}
		$this->db->select($select, false);

		$this->db->from('project_task AS pt');
		$this->db->join('project AS pr', 'pt.entity_id=pr.entity_id and pt.project_id = pr.project_id');
		$this->db->join('project_users AS pu', 'pr.entity_id = pu.entity_id and pr.project_id = pu.project_id AND pt.assignee_id=pu.user_id');		
		$this->db->join('task_type AS ty', 'pt.entity_id=ty.entity_id and pt.task_type_id=ty.task_type_id', 'left');		
		$this->db->where($where);

		if (isset($data['task_ids']))
		{
			$this->db->where_not_in('pt.task_id', $data['task_ids']);
		}
		if (!empty($data['project_ids']))
		{
			$this->db->where_in('pr.project_id', $data['project_ids']);
		}
		if (isset($data['task_id'])) {
			$this->db->where('pt.task_id', $data['task_id']);
		}
		if (!$raw_query)
			$this->db->order_by('pt.finish_date, pt.task_priority');
		$query	= $this->db->get();
		if ($raw_query)
			return $query;

		return $query->result_array();
	}

	public function get_list($select = '', $options = array(), $all=false, $raw_query = false)
	{
		$select = ($select)?$select:"t.time_sheet_id, t.project_id, t.task_type_id, t.project_task_id, pt.task_number, pt.task_priority, DATE_FORMAT(t.entry_date, '%Y-%m-%d') as entry_date, t.hours, t.notes, t.is_progress, if(t.user_id=t.approved_by,'',t.approval_status) AS approval_status, t.is_billable, t.invoice_id, pr.project_code, pr.project_name, pr.bg_color, t.activity_name, ty.name,pu.user_role, t.estimated_hours, t.approved_by, t.last_updated_date";
		$query = $this->list_query($select, $options, $all, $raw_query);

		if ($raw_query) 
			return $query;

		return $query->result_array();
	}

	public function get_details ($ids = array(), $select = 'td.time_sheet_id, td.time_sheet_detail_id, td.from_time, td.to_time, td.hours, td.is_progress')
	{

		$this->db->select($select);
		$this->db->from('time_sheet_detail AS td');
		$this->db->where('td.entity_id', $this->ot_app->get('entity_id'));
		$this->db->where_in('td.time_sheet_id', $ids);
		$this->db->order_by('td.time_sheet_id, td.from_time, td.to_time');
		$query = $this->db->get();

		return $query->result_array();
	}

	public function get_leave_days($to_timestamp=true, $repeat=null)
	{
		$week_list = array('Sunday'=>'SU','Monday'=>'MO','Tuesday'=>'TU','Wednesday'=>'WE','Thursday'=>'TH','Friday'=>'FR','Saturday'=>'SA');

		$this->db->select('dayoff_date,  description, repeat');
		$this->db->from('entity_daysoff');
		$this->db->where('entity_id', $this->ot_app->get('entity_id'));

		if ($repeat === true)
		{
			$this->db->where('repeat', '1');
		}
		elseif($repeat === false)
		{
			$this->db->where('repeat', '0');
		}

		$this->db->order_by('dayoff_date');

		$query = $this->db->get();

		$result	= $query->result_array();

		if ($to_timestamp == false)
		{
			return $result;
		}

		$return	= array();

		foreach ($result as $key=>$val)
		{
			$k	= mysql_to_unix($val['dayoff_date']);
			$return[$k]	= $val;
			$return[$k]['dayoff_date']	= mysql_to_unix($val['dayoff_date']);
		}

		return $return;
	}
	
	public function save($data)
	{
		$this->load->library('time_sheet_table');
		
		if (!$this->ot_app->get('time_sheet_approval'))
		{
			$data['approval_status']	= 'A';
		}
		
		// conditions used for when update data
		$params = array();
		if (!empty($data[$this->time_sheet_table->tbl_key]))
		{
			$params['where'] 		= array('user_id' => $data['user_id']);
			$params['where_str']	= "invoice_id = 0 AND (approved_by=0 OR approval_status='')";
		}
		$data['last_updated_by'] 	= $data['user_id'];
		$data['last_updated_date'] 	= $this->auth->get_timezone_date('Y-m-d H:i:s', 'UTC');
		
		return $this->time_sheet_table->save($data, $params); 
	}
	
	public function delete ($id)
	{
		$where = array('entity_id' => $this->ot_app->get('entity_id'),'time_sheet_id' => $id, 'user_id' => $this->ot_user->get('user_id'), 'is_progress' => 0);
		$this->db->select('concat("-", hours) AS hours, project_id,task_type_id, project_task_id', false);
		$this->db->where($where);
		$this->db->where("invoice_id = 0 AND (approved_by=0 or approval_status='')");
		$query = $this->db->get('time_sheet');
		$row = $query->row_array();		

		if ($row) {
			$this->db->where($where);
			$this->db->where("invoice_id = 0 AND (approved_by=0 or approval_status='')");
			if ($this->db->delete('time_sheet'))
			{
				$tmp = $this->delete_details($id);
				$this->load->library('time_sheet_table');
				$this->time_sheet_table->update_actual_value($row);
				
				// update task worked hours
				$hours = $row['hours'];
				$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'task_id' =>$row['project_task_id']));
				$this->db->set('worked_hours', 'worked_hours+'.$hours, FALSE);
				$this->db->update('project_task');

				return true;
			}
		}
				
		return false;
	}
	
	public function delete_details ($time_sheet_id, $ids = array(), $force = false)
	{
		// delete time sheet details
		if ($ids)
		{
			$this->db->where_in('time_sheet_detail_id', $ids);
		}
		$where = array('entity_id' => $this->ot_app->get('entity_id'), 'time_sheet_id' => $time_sheet_id);
		if (!$force) $where['is_progress'] = 0;

		$this->db->where($where);
		//$this->db->where("(approved_by=created_by or approval_status='')");
		$this->db->delete('time_sheet_detail');
		
		return ($ids)?$ids:true;
	}
	
	public function change_status ($where)
	{
		// submit for approval
		if ($where)
		{
			foreach ($where as $key=>$val)
			{
				$this->db->where(str_replace("t.",'',$key) , $val);
			}			
			$this->db->where(array('time_sheet.entity_id' => $this->ot_app->get('entity_id'), 'time_sheet.user_id' => $this->ot_user->get('user_id'), 'time_sheet.approval_status ' => '', 'time_sheet.is_progress' => 0, 'project.is_active' => 1));
			$this->db->set(array('time_sheet.approval_status' => 'S', 'time_sheet.last_updated_by' => $this->ot_user->get('user_id'), 'time_sheet.last_updated_date' => $this->auth->get_timezone_date('','UTC')));
			$this->db->update('time_sheet JOIN '.$this->db->dbprefix('project').' ON '.$this->db->dbprefix('time_sheet').'.project_id='.$this->db->dbprefix('project').'.project_id' );
			
			$this->response->success();
			return true;
		}		

		return false;
	}
	
	public function get_active_details ($select = '*' , $where= array())
	{
		$this->db->select($select, false);
		$this->db->from('time_sheet AS t');
		$this->db->join('project AS pr',  't.entity_id = pr.entity_id and t.project_id = pr.project_id', 'INNER');
		$this->db->join('time_sheet_detail AS td', 't.entity_id=td.entity_id AND t.time_sheet_id=td.time_sheet_id', 'LEFT');
		$this->db->where(array('t.entity_id' => $this->ot_app->get('entity_id'), 'td.is_progress' => 1));
		if (empty($where['t.user_id'])) {
			$where['t.user_id'] = $this->ot_user->get('user_id');
		}
		$this->db->where($where);
		$query = $this->db->get();

		return $query->row_array();
	}
	
	public function get_last_detail ($user_id = 0)
	{
		$user_id = (!is_member() && $user_id)?$user_id:$this->ot_user->get('user_id');
		$this->db->select('project_id, task_type_id');
		$this->db->from('time_sheet');
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $user_id));
		$this->db->order_by('time_sheet_id', 'desc');
		$this->db->limit(1);
		$query = $this->db->get();

		return $query->row_array();
	}
	
	public function start_job ($data)
	{
		$result		= array();
		
		// get current date
		$date = $this->get_current_datetime();
		$data = array_merge($data,$date);
		
		// get active jobs in current date
		// $active_res = $this->get_active_details('t.time_sheet_id', array('t.entry_date' => $data['cur_date']));
		$active_res = $this->get_active_details('t.time_sheet_id', array());
	
		// start current jobs
		if (!$result = $this->start_time_sheet($data)) {
			return false;		
		}

		// stop already running job
		if ($active_res)
		{
			$active_res['cur_datetime']	= $data['cur_datetime'];
			$active_res['cur_date'] 	= $data['cur_date'];
			$active_res['cur_time']		= $data['cur_time'];
			// $active_res['stop_old'] = 1;
		
			if (!$this->stop_job($active_res))
				return false;
		}
		
		
		// create new time detail
		$detail = array('time_sheet_id' => $result['time_sheet_id'], 'from_time' => $data['cur_time'], 'is_progress' => 1,'entity_id' => $this->ot_app->get('entity_id'));
		$this->db->insert('time_sheet_detail', $detail); 
		$result['detail_ids'] 	= $this->db->insert_id();
		$result['time'] 		= time_in_12_hour_format($data['cur_time'],true);
		
		// update actual start date
		$this->db->select('project_task_id');
		$this->db->from('time_sheet');
		$this->db->where(array('time_sheet_id' => $result['time_sheet_id'], 'entity_id' => $this->ot_app->get('entity_id'), 'project_task_id >' => 0));
		$this->db->where('(hours > 0 OR is_progress = 1)');
		$row = $this->db->get()->row_array();
		if ($row) {
			$this->db->where(array('task_id' =>$row['project_task_id'], 'entity_id' => $this->ot_app->get('entity_id')));
			// update actual start time						
			$this->db->set('actual_start_date', 'CASE WHEN `actual_start_date` IS NULL THEN "'.$this->auth->get_timezone_date('','UTC').'"  ELSE `actual_start_date` END', FALSE);
			$this->db->update('project_task');
		}
		
		run_background_process("toggleTimesheet", json_encode(array('time_sheet_id' => $result['time_sheet_id'], 'cur_time'=>time_in_12_hour_format($data['cur_time']), 'entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $this->ot_user->get('user_id'))));
		return $result;
	}
	
	public function start_time_sheet ($data)
	{
		$time_sheet_id = !empty($data['time_sheet_id'])?$data['time_sheet_id']:0;
		
		if (!isset($data['cur_date']) || strtotime($data['cur_date'])<strtotime($this->auth->get_timezone_date('Y-m-d',true)))
		{
			$date = $this->get_current_datetime();
			$data = array_merge($data,$date);
		}
				
		// start job
		if ($time_sheet_id)
		{
			// check timesheet date
			$query = $this->db->get_where('time_sheet', array('entity_id' => $this->ot_app->get('entity_id'), 'time_sheet_id' => $time_sheet_id));
			$sheet = $query->row_array();

			if (empty($sheet))
			{
				$this->response->error('TIMESHEET_NOT_FOUND');
				return false;
			}

			if ($sheet['invoice_id'] || strtotime(date('Y-m-d', strtotime($sheet['entry_date'])))<strtotime($this->auth->get_timezone_date('Y-m-d',true)))
			{
				$sheet['time_sheet_id'] = 0;
				unset($sheet['last_updated_by']);
				unset($sheet['last_updated_date']);
				$sheet['hours'] = 0;
				$sheet['entry_date'] = $data['cur_date'];
				$sheet['invoice_id'] = 0;
				if (!$result =  $this->save($sheet))
				{
					return $result;
				}
				$time_sheet_id = $result['time_sheet_id'];
			}
			
			// update existing record
			$this->db->where(array('time_sheet_id' => $time_sheet_id, 'entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $this->ot_user->get('user_id'), 'entry_date' => $data['cur_date'],'invoice_id ' => '0', 'is_progress' => 0));
			$this->db->where('(approved_by=0 or approval_status="")');
			$this->db->update('time_sheet', array('is_progress' => 1, 'last_updated_by' => $this->ot_user->get('user_id'), 'last_updated_date' => $this->auth->get_timezone_date('Y-m-d H:i:s', 'UTC')));
			
			// if rows affected retun timesheet id
			if ($this->db->affected_rows())
				return array('time_sheet_id' => $time_sheet_id);

		} else {
			// strip non required fields
			$this->load->library('table_fields');
			$data = $this->table_fields->strip_fields('timesheets', $data);
			if (!$data)
			{
				$this->response->error($this->table_fields->error, true);			
				return false;
			}
			$data['is_progress'] = 1;
			if ($result = $this->save($data))
			{
				return $result;	
			}
		}
		
		$this->response->error('UNABLE_START');
		return false;
	}
	
	public function stop_job ($data)
	{
		/*/if (!isset($data['cur_date']) || strtotime($data['cur_date'])<strtotime($this->auth->get_timezone_date('Y-m-d')))
		{
			$date = $this->get_current_datetime();
			$data = array_merge($data,$date);
		}*/
		
		$this->db->select('t.*, td.time_sheet_detail_id, td.from_time');
		$this->db->from('time_sheet AS t');
		$this->db->join('time_sheet_detail AS td', 't.entity_id=td.entity_id and t.time_sheet_id=td.time_sheet_id', 'INNER');
		$this->db->where(array('t.entity_id' => $this->ot_app->get('entity_id'), 't.time_sheet_id' => $data['time_sheet_id'], 'td.is_progress' => 1));
		
		$query	= $this->db->get();
		
		$row	= $query->row();
		
		if (!$row)
		{
			return false;
		}
		
		if (!isset($data['cur_date']) || strtotime($data['cur_date'])<strtotime($this->auth->get_timezone_date('Y-m-d')))
		{
			$date = $this->get_current_datetime();
			$data = array_merge($data,$date);
		}
	
		
		// old date timesheet
		$diff_days = (strtotime($data['cur_date'])-strtotime($row->entry_date)) / 86400;
		
		if ($diff_days) {
			$cur_time			= date('H:i:s', strtotime($data['cur_time']));
			$data['cur_time']	= date('H:i:s', strtotime('23:59:59'));
			$data['from_time']	= date('H:i:s', strtotime($row->from_time));
		} else {
			$data['cur_time']	= date('H:i:s', strtotime($data['cur_time']));
			$data['from_time']	= date('H:i:s', strtotime($row->from_time));
		}
		
		$hours		= (strtotime($data['cur_time']) - strtotime($data['from_time']))/3600;
		
		if ($hours) {
			$data['from_time']	= date('H:i', strtotime($row->from_time));
			$data['cur_time']	= date('H:i', (strtotime($row->from_time) + (floor($hours*60)*60)));
			$hours		= round((strtotime($data['cur_time']) - strtotime($data['from_time']))/3600,2);
		} else {
			$data['cur_time']	= date('H:i', strtotime($data['cur_time']));
			$data['from_time']	= date('H:i', strtotime($row->from_time));
		}
		
		$t_hours	= $row->hours + $hours;
		
		// update time sheet detail
		$result = array('hours' => $t_hours);
		$where = array('time_sheet_detail_id' => $row->time_sheet_detail_id);
//		if (!is_member()) {
//			unset($where['user_id']);
//		}
		$this->db->where($where);
		if ($hours <= 0) {
			$this->db->delete('time_sheet_detail');
			$result['deleted_ids'] = array($row->time_sheet_detail_id);
		} else {
			$this->db->update('time_sheet_detail', array('is_progress' => 0, 'hours' =>$hours, 'from_time'=> $data['from_time'], 'to_time' => $data['cur_time'], 'updated_by' => $this->ot_user->get('user_id'), 'updated_date' => $data['cur_datetime']));
			$result['detail_ids'] 	= array($row->time_sheet_detail_id);
			$result['time'] 		= time_in_12_hour_format($data['cur_time']);
			
			if ($row->project_task_id) {
				// update worked hours
				$this->db->where(array('task_id' =>$row->project_task_id, 'entity_id' => $this->ot_app->get('entity_id')));
				$this->db->set('worked_hours', 'worked_hours+'.$hours, FALSE);
				$this->db->update('project_task');
			}
				
		}

		$result['time_sheet_id'] = $this->stop_time_sheet($data, $t_hours);
		// add timesheet for previous days
		if ($diff_days) {
			$sheet = (array)$row;
			unset($sheet['last_updated_by']);
			unset($sheet['last_updated_date']);
			for($i=1;$i<=$diff_days;$i++) {
				$sheet['time_sheet_id'] = 0;
				$sheet['hours'] = 0;
				$sheet['is_progress'] = 0;
				$date = strtotime("+".$i." days", strtotime($row->entry_date));
				$sheet['entry_date'] = date("Y-m-d", $date);
				$sheet['invoice_id'] = 0;
				$details	= array();
				$details[0]['from_time'] 	= '12:00 AM';
				$details[0][is_progress]	=	0;
				$details[0]['to_time'] 		= '11:59 PM';
				if ((strtotime($data['cur_date'])==strtotime($sheet['entry_date'])))
				{
					/*if(!isset($data['stop_old'])) {
						$details[0][is_progress]	= 1;
						$details[0]['to_time'] 		= '';
						$sheet['is_progress'] = 1;
					} else {*/
						$details[0]['to_time'] 	= $cur_time;
					// }
				}
				
				$sheet['details']	=	$details;
				if (!$result =  $this->save($sheet))
				{
						// print_r($result);
				}
			}
		}

		run_background_process("toggleTimesheet", json_encode(array('time_sheet_id' => $data['time_sheet_id'], 'entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $this->ot_user->get('user_id'))));
		
		return $result;
	}
	
	public function stop_time_sheet ($data, $t_hours)
	{
		if (!isset($data['cur_date']) || strtotime($data['cur_date'])<strtotime($this->auth->get_timezone_date('Y-m-d')))
		{
			$date = $this->get_current_datetime();
			$data = array_merge($data,$date);
		}
		
		// update time sheet
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'time_sheet_id' => $data['time_sheet_id'] , 'user_id' => $this->ot_user->get('user_id'), 'invoice_id ' => '0', 'is_progress' => 1));
		$this->db->where('(approved_by=0 or approval_status="")');
		$this->db->update('time_sheet', array('is_progress' => 0, 'hours' =>$t_hours, 'last_updated_by' => $this->ot_user->get('user_id'), 'last_updated_date' => $this->auth->get_timezone_date('Y-m-d H:i:s', 'UTC')));
		
		return $data['time_sheet_id'];
	}
	
	public function get_current_datetime()
	{
		$date['cur_datetime']	= $this->auth->get_timezone_date('Y-m-d H:i:s', true);
		$date['cur_date'] 		= date('Y-m-d', strtotime($date['cur_datetime'])); 
		$date['cur_time']		= date('H:i:s', strtotime($date['cur_datetime']));
		
		return $date;
	}
	
	public function get_total_hours($options = array())
	{
		
		$this->db->select('sum(hours) AS day_total, is_billable');
		$this->db->select("DATE_FORMAT(entry_date, '%Y-%m-%d') as entry_date", false);
		$this->db->select("invoice_id");
		$this->db->from('time_sheet');
		
		$where	= array(
			'entity_id'	=> $this->ot_app->get('entity_id'),
			'user_id'	=> $this->ot_user->get('user_id')
		);

		if (!empty($options['filters']))
		{
			$where	= array_merge($where, $options['filters']);
		}
		$this->db->where($where);

		if (!empty($options['where_str']))
		{
			$this->db->where($options['where_str'], NULL, FALSE);
		}

		$group_by = !empty($options['group_by'])?$options['group_by']:'entry_date';	
		$this->db->group_by($group_by);

		$query = $this->db->get();

		return $query->result_array();
	}

	public function set_details($row)
	{
		$result	= $row;
		$sec = !empty($row['is_progress'])?true:false;
		$result['from_time']= time_in_12_hour_format($row['from_time'],$sec);
		$result['to_time']	= !empty($row['to_time']) ? time_in_12_hour_format($row['to_time'],$sec) : '';

		return $result;
	}
	
	public function get_time_details($data)
	{
		$this->db->select('td.from_time,td.to_time, td.hours, td.is_progress');
		$this->db->from('time_sheet AS t');
		$this->db->join('time_sheet_detail AS td', 't.entity_id=td.entity_id and t.time_sheet_id=td.time_sheet_id', 'INNER');
		$where = array();
		if (!empty($data['time_sheet_id']))
			$where['t.time_sheet_id'] = $data['time_sheet_id'];
		if (!empty($data['user_id']))
			$where['t.user_id'] = $data['user_id'];
		if (!empty($data['date']))
			$where['t.entry_date'] = $data['date'];
			
		$this->db->where(array('t.entity_id' => $this->ot_app->get('entity_id')));
		$this->db->where($where);
		$query = $this->db->get();
// echo $this->db->last_query();
		$result =  $query->result_array();
		
		if ($result)
		{
			foreach ($result as $key=>$val)
			{
				$result[$key] = $this->set_details($val);
			}
		}
		
		return $result;
	}

	public function get_task_count($entity_id=0, $user_id=0)
	{
		$entity_id	= $entity_id ? $entity_id : $this->ot_app->get('entity_id');
		$user_id	= $user_id ? $user_id : $this->ot_user->get('user_id');

		$this->db->select('pt.task_id');
		$this->db->from('project_task AS pt');
		$this->db->where(array(
			'pt.entity_id'	=> $entity_id,
			'pt.is_closed'	=> '0',
			'pt.assignee_id'	=> $user_id
		));

		$query	= $this->db->get();

		return count($query->result_array());
	}

	public function get_team_users($select = '', $filter_users = array(), $filter_projects=array(), $isActive=true)
	{
		return $this->get_user_info($select, $filter_users, $filter_projects, $isActive);
	}

	public function get_user_info($select = '', $filter_users = array(), $filter_projects=array(), $isActive=true)
	{
		// get related users
		$select = $select ? $select : 'eu.user_id, eu.first_name, eu.last_name, eu.user_image';
		$this->db->select($select);
		$this->db->from('entity_users AS eu');
		$this->db->where(array(
			'eu.entity_id'	=> $this->ot_app->get('entity_id'),
			'eu.user_id'	=> $this->ot_user->get('user_id')
		));
		$query = $this->db->get();
		$users = $query->result_array();

		return $users;
	}

	public function save_notes($data) {

		if (!empty($data['time_sheet_id'])) {
				$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'time_sheet_id' =>$data['time_sheet_id']));
				$this->db->set('notes', $data['notes']);
				$this->db->update('time_sheet');

				return true;
		}
		return false;
	}
}
/* End of file */
