<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	set_cache_header();
?>
<div id="entity-setting">
	<div class="page-header-bar">
		<span class="title"><?php echo lang('SETTINGS'); ?></span>
		<div id="alert_message" class="ac col-md-9 fix-it"></div>
	</div>
	<div class="row">
		<!-- ko with:company -->
		<?php $this-> load->view('entity/company'); ?>
		<!-- /ko -->
		<!-- ko with:datetime -->
		<?php $this-> load->view('entity/datetime'); ?>
		<!-- /ko -->
		<!-- ko with:timesheet -->
		<?php $this-> load->view('entity/timesheet'); ?>
		<!-- /ko -->
	</div>
	<div class="row">
		<!-- ko with:invoice -->
		<?php $this-> load->view('entity/invoice'); ?>
		<!-- /ko -->
		<!-- ko with:calendar -->
		<?php $this-> load->view('entity/calendar'); ?>
		<!-- /ko -->
		<!-- ko with:taskTypes -->
		<?php $this-> load->view('entity/taskTypes'); ?>
		<!-- /ko -->
	</div>
	<div class="row">
		<!-- ko with:expenses -->
		<?php $this-> load->view('entity/expenses'); ?>
		<!-- /ko -->
		<!-- ko with:taskStatus -->
		<?php $this-> load->view('entity/taskStatus'); ?>
		<!-- /ko -->
		<!-- ko with:department -->
		<?php $this-> load->view('entity/department'); ?>
		<!-- /ko -->
	</div>
	<div class="row">
		<!-- ko with:smtp -->
		<?php $this-> load->view('entity/smtp'); ?>
		<!-- /ko -->
		<!-- ko with:addon -->
		<?php $this-> load->view('entity/addon'); ?>
		<!-- /ko -->
		<!-- ko template:{name:'about-tmpl'} --><!-- /ko -->
	</div>
</div>
<?php
	$jslang	= array();
	$tmp	= array(
		'ERR_EXPENSE_NAME_REQUIRED',
		'ERR_EXPENSE_AMOUNT_REQUIRED',
		'ERR_EXPENSE_SESSION_REQUIRED',
		'ERR_USER_DEPT_NAME_REQUIRED',
		'ERR_TASK_TYPE_NAME_REQUIRED',
		'ERR_TASK_TYPE_AMOUNT_REQUIRED',
		'ERR_TASK_STATUS_NAME_REQUIRED',
		'ERR_FIRST_SAVE_OR_CANCEL_DATA',
		'ERR_FIRST_ADD_OR_CANCEL_DATA',
		'DEFAULT_TYPE',
		'NON_DEFAULT',
		'ERR_DATE_IS_REQUIRED',
		'ERR_DATE_TEXT_IS_REQUIRED',
		'INVALID_DETAILS',
		'MONDAY',
		'TUESDAY',
		'WEDNESDAY',
		'THURSDAY',
		'FRIDAY',
		'SATURDAY',
		'SUNDAY',
		'JANUARY',
		'FEBRUARY',
		'MARCH',
		'APRIL',
		'MAY',
		'JUNE',
		'JULY',
		'AUGUEST',
		'SEPTEMBER',
		'OCTOBER',
		'NOVEMBER',
		'DECEMBER'
	);

	foreach ($tmp as $val)
	{
		$jslang[$val]	= lang($val);
	}

	$timeZones	= array();
	if(!empty($time_zones))
	{
		foreach($time_zones as $zone)
		{
			$timeZones[$zone['time_zone_code']]	= $zone['description'];
		}
	}
	$currencies	= array();
	if(!empty($currency))
	{
		foreach($currency as $val)
		{
			$currencies[$val['currency_code']]	= $val;
		}
	}
?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.Entity.language	= <?php echo json_encode($jslang); ?>;
		Otime.Entity.timeZones	= <?php echo json_encode($timeZones); ?>;
		Otime.Entity.currencies	= <?php echo json_encode($currencies); ?>;
		Otime.Entity.date_formats	= <?php echo json_encode($this->config->item('date_formats')); ?>;
		Otime.Entity.number_formats	= <?php echo json_encode($this->config->item('number_formats')); ?>;
		Otime.Entity.time_round_to	= <?php echo json_encode($this->config->item('time_round_to')); ?>;
	});
</script>
