<?php	if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$is_ajax_request	= $this->input->is_ajax_request();

	if (!$is_ajax_request)
	{
		$this->load->view("header");
	}
	
	$date_filter_this	= array(
		'ALL' => 'ALL',
		'TO' => 'TODAY',
		'TW' => 'THIS_WEEK',
		'TS' => 'THIS_SEMI_MONTHLY',
		'TM' => 'THIS_MONTH',
		'TQ' => 'THIS_QUARTER',
		'TY' => 'THIS_YEAR',
		'TA' => 'THIS_ACCOUNT_YEAR'
	);
	$date_filter_last	= array(
		'YE' => 'YESTERDAY',
		'LW' => 'LAST_WEEK',
		'LS' => 'LAST_SEMI_MONTHLY',
		'LM' => 'LAST_MONTH',
		'LQ' => 'LAST_QUARTER',
		'LY' => 'LAST_YEAR',
		'LA' => 'LAST_ACCOUNT_YEAR'
	);
?>

<div id="invoice-container" class="cutter-top col-md-12" style="max-width:1200px;">
	<div style="max-width:1150px;margin:0 auto;">
		<div class="page-header-bar">
			<div id="alert_message" class="ac col-md-9 fix-it"></div>
			<?php if($view == "deposit"): ?>
			<span class="title"><?php echo lang('DEPOSIT_INVOICE'); ?></span>
			<?php else: ?>
				<span class="title"><?php echo lang('INVOICE'); ?></span>
			<?php endif;?>
			<ul class="btns list-inline">
				<!-- ko if:(!is_edit_mode() || is_view_mode()) -->
				<li class="img-circle icon40 cp" data-bind="click:addItem">
					<span><i class="icon-plus icon-metro img-circle"></i></span>
				</li>
				<!-- /ko -->
				<!-- ko if:is_edit_mode -->
				<li class="img-circle icon40 cancel cp" data-bind="click:cancel_edit">
					<span><i class="icon-arrow-left icon-metro img-circle"></i></span>
				</li>
				<!-- /ko -->
				<?php if (is_admin()) { ?> 
					<!-- ko if:(!is_edit_mode() || is_view_mode()) -->
					<li class="img-circle icon40 cp" data-bind="click:show_comments">
						<span><i class="icon-metro img-circle icon-ellipsis-horizontal"></i></span>
					</li>
					<!-- /ko -->
				<?php } ?>
			</ul>
		</div>
		<div id="body-container" class="np" data-bind="hidden:is_view_mode()==false&&is_edit_mode()==true, css:{'col-md-12':is_view_mode()==false,'invoice-list col-lg-8 hidden-xs hidden-sm':is_view_mode}" class="pull-left">
			<div class="container np">
				<div class="col-md-3 pull-right" data-bind="hidden:is_view_mode()==false&&is_edit_mode()==false"></div>
				<div class="col-md-6 pull-right row npr filter">
					<div class="col-md-12 form-group pull-right" data-bind="visible:Object.values(clients()).length>0">
						<select class="select filters form-control" data-bind="options:Object.values(clients()), optionsText:'client_name', optionsValue:'client_id', selectedOptions:sel_client, chosen:true" multiple="multiple" style="margin-right:82px;"></select>
					</div>
				</div>
				<div class="col-md-3 pull-right">
					<input type="text" class="form-control" placeholder="Search Invoice No." data-bind="numberOnly:true, value:search_invoice, valueUpdate:'afterkeydown', event:{keydown:$root.search}" />
				</div>
			</div>
			<div class="col-md-12 np">
				<ul class="nav nav-tabs">
					<?php if (is_admin()): ?>
					<li class="active" data-bind="css:{'active':invoice_status()=='U'}, click:changeInvoice('U')">
						<a href="javascript:;" ><?php echo lang('UNPAID'); ?>&nbsp;<span class="badge small" style="font-weight: normal;" data-bind="visible:_info.count_b()>0, text:_info.count_b()"></span></a>
					</li>
					<?php endif; ?>
					<li data-bind="css:{'active':invoice_status()=='D'}, click:changeInvoice('D')">
						<a href="javascript:;" ><?php echo lang('DRAFT'); ?>&nbsp;<span class="badge small" style="font-weight: normal;" data-bind="visible:_info.count_d()>0, text:_info.count_d()"></span></a>
					</li>
					<?php if (is_admin()): ?>
					<li data-bind="css:{'active':invoice_status()=='P'}, click:changeInvoice('P')">
						<a href="javascript:;" ><?php echo lang('PAID'); ?>&nbsp;<span class="badge small" style="font-weight: normal;" data-bind="visible:_info.count_p()>0, text:_info.count_p()"></span></a>
					</li>
					<?php endif; ?>
					<?php if($view != "deposit"): ?>
					<li data-bind="css:{'active':invoice_status()=='R'}, click:changeInvoice('R')">					
						<a href="javascript:;"><?php echo lang('RECURRING'); ?></a>
					</li>
					<?php endif; ?>
					<li data-bind="css:{'active':invoice_status()=='A'}, click:changeInvoice('A')">					
						<a href="javascript:;"><?php echo lang('ARCHIVED'); ?></a>
					</li>
				</ul>
			</div>
			<div class="clearfix">&nbsp;</div>
			<div class="col-md-12 table-responsive" style="padding:0 0 140px 0">
				<table data-bind="visible:items().length>0" cellpadding="0" cellspacing="0" border="0" class="table table-striped table-hover">
					<thead>
						<tr>
							<?php if($view == 'estimate') { ?>
							<th class="wnw cp" data-bind="click:function(params) { sort('estimate_date'); }"><?php echo lang('DATE'); ?>
								<!--  ko if:(columns()['estimate_date'] && columns()['estimate_date'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['estimate_date'].is_asc(), 'icon-caret-down':!columns()['estimate_date'].is_asc() }"></i><!-- /ko -->
							</th>
							<?php } else { ?>
							<th class="wnw cp" data-bind="click:function(params) { sort('invoice_date'); }"> <?php echo lang('DATE'); ?>
								<!--  ko if:(columns()['invoice_date'] && columns()['invoice_date'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['invoice_date'].is_asc(), 'icon-caret-down':!columns()['invoice_date'].is_asc() }"></i><!-- /ko -->	
							</th>
							<?php } ?>
							<?php if($view == 'estimate') { ?>
							<th class="wnw cp" data-bind="click:function(params) { sort('estimate_number'); }"><?php echo lang('ESTIMATE'); ?>
								<!--  ko if:(columns()['estimate_number'] && columns()['estimate_number'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['estimate_number'].is_asc(), 'icon-caret-down':!columns()['estimate_number'].is_asc() }"></i><!-- /ko -->
							</th>
							<?php } else { ?>
							<th class="wnw cp" data-bind="click:function(params) { sort('invoice_number'); }"><?php echo lang('INVOICES'); ?>
								<!--  ko if:(columns()['invoice_number'] && columns()['invoice_number'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['invoice_number'].is_asc(), 'icon-caret-down':!columns()['invoice_number'].is_asc() }"></i><!-- /ko -->
							</th>
							<?php } ?>
							<th class="wnw cp" data-bind="click:function(params) { sort('client_name'); }"><?php echo lang('CLIENT'); ?>
								<!--  ko if:(columns()['client_name'] && columns()['client_name'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['client_name'].is_asc(), 'icon-caret-down':!columns()['client_name'].is_asc() }"></i><!-- /ko -->
							</th>
							<th data-bind="click:function(params) { sort('amount'); }" class="wnw cp ar"><?php echo lang('AMOUNT'); ?>
								<!--  ko if:(columns()['amount'] && columns()['amount'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['amount'].is_asc(), 'icon-caret-down':!columns()['amount'].is_asc() }"></i><!-- /ko -->
							</th>
							<th data-bind="visible:invoice_status()=='U', click:function(params) { sort('amount'); }" class="wnw cp ar"><?php echo lang('BALANCE_AMOUNT'); ?>
								<!--  ko if:(columns()['amount'] && columns()['amount'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['amount'].is_asc(), 'icon-caret-down':!columns()['amount'].is_asc() }"></i><!-- /ko -->
							</th>
							<th data-bind="visible:invoice_status()=='P', click:function(params) { sort('last_updated_date'); }" class="wnw cp ar"><?php echo lang('PAID_ON'); ?>
								<!--  ko if:(columns()['last_updated_date'] && columns()['last_updated_date'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['last_updated_date'].is_asc(), 'icon-caret-down':!columns()['last_updated_date'].is_asc() }"></i><!-- /ko -->
							</th>
							<th data-bind="visible:invoice_status()=='R', click:function(params) { sort('recurring_next_inv_date'); }" class="wnw cp ar"><?php echo lang('NEXT_INVOICE_DATE'); ?>
								<!--  ko if:(columns()['recurring_next_inv_date'] && columns()['recurring_next_inv_date'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['recurring_next_inv_date'].is_asc(), 'icon-caret-down':!columns()['recurring_next_inv_date'].is_asc() }"></i><!-- /ko -->
							</th>
							<th data-bind="visible:invoice_status()=='D', click:function(params) { sort('due_date'); }" class="wnw cp ar"><?php echo lang('DUE_DATE'); ?>
								<!--  ko if:(columns()['due_date'] && columns()['due_date'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['due_date'].is_asc(), 'icon-caret-down':!columns()['due_date'].is_asc() }"></i><!-- /ko -->
							</th>
							<th data-bind="click:function(params) { sort('status'); }" class="wnw cp text-center" style="width:130px;"><?php echo lang('STATUS'); ?>
								<!--  ko if:(columns()['status'] && columns()['status'].is_sorted()) --><i data-bind="css:{'icon-caret-up':columns()['status'].is_asc(), 'icon-caret-down':!columns()['status'].is_asc() }"></i><!-- /ko -->
							</th>
							<th style="width:50px;"></th>
						</tr>
					</thead>
					<tbody data-bind="foreach:items">
						<?php if($view == 'estimate'): ?>
						<tr class="cp">
							<td data-bind="click:$parent.viewItem, text:estimate_date"></td>
							<td data-bind="click:$parent.viewItem, text:estimate_number"></td>
							<td data-bind="click:$parent.viewItem, text:_info.client_name()"></td>
							<td class="ar" data-bind="click:$parent.viewItem, currency:{val:_info.total, symbol:_info.currency}"></td>
							<td>
								<div class="btn-group">
									<button type="button" class="btn btn-status" data-bind="css:status_class(), text:status_display"></button>
									<?php if(is_admin()): ?>
									<button type="button" class="btn dropdown-toggle" data-bind="css:status_class()" data-toggle="dropdown">
										<span class="caret"></span>
									</button>
									<ul class="dropdown-menu al" role="menu">
									<?php
										foreach ($status as $key=>$val)
										{
											echo '<li> <a href="javascript:;" data-bind="click:function(){update_status(\''.$key.'\');}">' . $val . '</a></li>';
											/*if ($key=='S')
											 {
											 echo '<li data-bind="click:prepareMail"> <a href="javascript:;" data-bind="click:function(){update_status(\''.$key.'\');}">' . $val . '</a></li>';
											 }*/
											//echo '<li data-bind="attr:{ href :\''.$key.'\' ==\'S\' ? \'#e-mails\':\'\' , \'data-toggle\' : \''.$key.'\'==\'S\' ? \'modal\':\'\' }" ><a href="javascript:;" data-bind="click:function(){update_status(\''.$key.'\');}">' . $val . '</a></li>';
										}
									?>
									</ul>
									<?php endif; ?>
								</div>
							</td>
							<td>
								<div class="dropdown">
									<label class="dropdown-toggle" data-toggle="dropdown">&nbsp;&nbsp;&nbsp;&nbsp;<i class="icon-cog"></i>
									</label>
									<ul class="dropdown-menu">
										<li><a data-bind="click:print" href="javascript:;"><?php echo lang('PRINT'); ?></a></li>
										<li><a data-bind="click:duplicate" href="javascript:;"><?php echo lang('DUPLICATE'); ?></a></li>
										<li>
											<a href="javascript:;" data-bind="click:$parent.remove">
												<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('DELETE'); ?>
											</a>
										</li>
									</ul>
								</div>
							</td>
						</tr>
						<?php else: ?>
						<tr class="cp">
							<td data-bind="click:$parent.viewItem" class="wnw vam">														 
								<span data-bind="css:{'due_iconspace': overdue()==true}" title="<?php echo lang('OVERDUE');?>"><i data-bind="visible:overdue()==false" class="icon-warning-sign" style="color: #b94a48;"></i></span>&nbsp;
							 	<span data-bind="date:invoice_date"></span>
							</td>
							<td data-bind="click:$parent.viewItem" class="wnw vam">
								<span data-bind="css:{'rec_iconspace': recurring_mode()==0}" title="<?php echo lang('RECURRING');?>"> <i data-bind="visible:recurring_mode()!=0" class="icon-refresh"></i></span>&nbsp;
							 	<span data-bind="text:invoice_number"></span>
							 </td>
							<td data-bind="click:$parent.viewItem, text:_info.client_name()" class="vam"></td>
							<td class="wnw ar vam" data-bind="click:$parent.viewItem">
								<span class="col-md-12 np" data-bind="currency:{val:_info.total, symbol:_info.currency}"></span>
								<?php if($view == "deposit"): ?>
								<br/>
								<div class="col-md-12 deposit-list pr" data-bind="visible:_info.applied_invoice() > 0">
									<div data-bind="event: {mouseenter: show_dep_tbl, mouseleave: hide_dep_tbl }">
										<span class="h6 pull-left dib"><?php echo lang('APPLIED_INVOICES'); ?></span>
										<span class="h5 dib" data-bind="currency:{val:_info.applied_invoice, symbol:_info.currency}"></span>
									</div>
									<!-- ko if:isDepTbl -->
									<ul class="dropdown-menu col-md-12 deposit-table">
										<!-- ko foreach:_info.applied_list -->
										<li>
											<small class="pull-left" data-bind="text:'<?php echo lang('INVOICE#'); ?>'+invoice_number"></small>
											<small class="pull-right" data-bind="currency:{val:amount, symbol:$parent._info.currency}"></small>
										</li>
										<!-- /ko -->
										<li class="divider np nm"></li>
										<li>
											<span class="pull-left"><?php echo lang('REMAINING'); ?></span>
											<span class="pull-right" data-bind="currency:{val:_info.remaining, symbol:_info.currency}"></span>
										</li>
									</ul>
									<!-- /ko -->
								</div>
								<?php endif; ?>
							</td>
							<td class="wnw ar vam" data-bind="visible:$root.invoice_status()=='U', click:$parent.viewItem, currency:{val:_info.total()-_info.payment_amount(), symbol:_info.currency}"></td>							
							<td class="wnw ar vam" data-bind="visible:$root.invoice_status()=='P', click:$parent.viewItem, date:last_updated_date"></td>
							<td class="wnw ar vam" data-bind="visible:$root.invoice_status()=='R', click:$parent.viewItem, date:recurring_next_inv_date"></td>
							<td class="wnw ar vam" data-bind="visible:$root.invoice_status()=='D', click:$parent.viewItem, date:due_date"></td>
							<td class="wnw text-center">
								<div class="btn-group">
									<button type="button" class="btn btn-status" data-bind="style:{width:(status()=='p' || status()=='b') ? '105px' : '' }, css:status_class(),text:status_display"></button>
									<?php if(is_admin()): ?>
									<!-- ko if:status()!="b"&&status()!="p"&&_info.is_archive()=='0' -->
									<button type="button" class="btn btn-list dropdown-toggle" data-bind="css:status_class()" data-toggle="dropdown">
										<span class="caret"></span>
									</button>
									<ul class="dropdown-menu al" data-bind="foreach:_info.status">
										<!-- ko if:$data.status!="b"&&$data.status!="p" -->
											<li><a href="javascript:;" data-bind="click:function(){$parent.update_status($data.status);}"><!-- ko text:$data.value --> <!-- /ko --></a></li>
										<!-- /ko -->
										<?php /*
											foreach (array_slice($status, 0, 2) as $key=>$val):											
												echo('<li><a href="javascript:;" data-bind="click:function(){update_status(\''.$key.'\');}">' . $val . '</a></li>');
											endforeach;*/
										?>
									</ul>
									<!-- /ko -->
									<?php endif; ?>
								</div>
							</td>
							<td>
								<div class="dropdown">
									<label class="dropdown-toggle" data-toggle="dropdown">&nbsp;&nbsp;&nbsp;&nbsp;<i class="icon-cog"></i></label>
									<ul class="dropdown-menu" style="left:-120px;">
										<!-- ko if:status()!="d" -->
											<li><a data-bind="click:$parent.viewItem" href="javascript:;"><?php echo lang('VIEW'); ?></a></li>
										<!-- /ko -->
										<!-- ko if:status()=="d" -->
											<li><a data-bind="click:$parent.viewItem" href="javascript:;"><?php echo lang('VIEW_OR_EDIT'); ?></a></li>
										<!-- /ko -->
										<?php if(is_admin()) { ?>
										<!-- ko if:status()!="p"  && status()!="r" &&  _info.is_archive()=='0'-->
										<li><a data-bind="click:$parent.payment" href="javascript:;"><?php echo lang('PAYMENT'); ?></a></li>
										<!-- /ko -->
										<?php } ?>
										<li><a data-bind="click:print" href="javascript:;"><?php echo lang('PRINT'); ?></a></li>
										<li><a data-bind="click:duplicate" href="javascript:;"><?php echo lang('DUPLICATE'); ?></a></li>
										<li><a data-bind="click:download_pdf" href="javascript:;"><?php echo lang('EXPORT_AS_PDF'); ?></a></li>							
									<!-- ko if:status()!="d" || status()!="a" -->
										<li>
											<a href="javascript:;" data-bind="click:$root.archiveItem()">
												<!-- ko ifnot:_info.is_archive() -->
													<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('ARCHIVE'); ?>
												<!-- /ko -->
												<!-- ko if:_info.is_archive() -->
													<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('UNARCHIVE'); ?>
												<!-- /ko -->
											</a>
											<!-- /ko -->
										</li>
										<!-- ko if:_info.is_archive() -->
										<li data-bind="visible:status()=='d'">
											<a href="javascript:;" data-bind="click:$parent.remove">
												<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('DELETE'); ?>
											</a>
										</li>
										<!-- /ko -->
									<!-- /ko -->
									</ul>
								</div>
							</td>
						</tr>
						<?php endif; ?>
					</tbody>
				</table>
				<div class="text-center" data-bind="visible:_info.notify_text() && items().length<=0" style="margin-top: 50px;">
					<span class="well" data-bind="text:_info.notify_text()"></span>
				</div>
			</div>
		</div>
		<div class="modal" id="payment-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-bind="with:paymentPopUp">					
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header npb">
						<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
						<div class="clearfix">&nbsp;</div>
						<div class="row nm">
							<div class="pull-left">
								<br/>
								<h3 class="no-margin" data-bind="text:'<?php echo lang('INVOICE'); ?> '+invoice_number()"></h3>
							</div>
							<div class="pull-right">
								<!-- ko if:_info.outstanding_amount -->
								<span class="pull-right"><?php echo lang('BALANCE'); ?></span>
								<br/>
								<h2 class="pull-right nmt" data-bind="currency:{val:_info.outstanding_amount, symbol:_info.currency}"></h2>
								<br/>
								<!-- /ko -->
								<h6 class="pull-right"><?php echo lang('TOTAL'); ?>:&nbsp;<span class="pull-right" data-bind="currency:{val:_info.total, symbol:_info.currency}"></span></h6>
							</div>
						</div>					
						<div class="row nm">
							<div class="pull-left">
								<h4><?php echo lang('PAYMENT'); ?></h4>
							</div>
							<div class="pull-right col-md-3">
								<h4><?php echo lang('AMOUNT'); ?></h4>
							</div>
						</div>
					</div>
					<div class="modal-body">
						<form class="np" role="form">
							<div class="">
								<div class="row" data-bind="with:_info.payment_add">
									<div class="col-md-4 input-group pull-left">
										<div style="position:relative;" class="pull-left">
											<h4 style="padding:4px 6px;" class="pull-left nm" data-bind="text:nav_date"></h4>
											<input type="text" id="date-picker" readonly="true" data-bind="value:payment_date, datepicker:{autoclose:true}" class="input-sm dtpicker npl npr cp">
										</div>
										<div class="pull-left">
											<button type="button" class="btn icon-chevron-up split up no-bg np" data-bind="click:dtchange('+1')"></button>
											<button type="button" class="btn icon-chevron-down split no-bg np" data-bind="click:dtchange('-1')"></button>
										</div>
									</div>
									<div class="col-md-4">
										<input class="form-control" type="text" placeholder="<?php echo lang('PAYMENT'); ?> #" data-bind="value:payment_number" maxlength="12"/>
									</div>
									<div class="col-md-4">
										<input class="ar form-control" type="text" placeholder="<?php echo lang('AMOUNT'); ?>" data-bind="numberOnly:true, value:amount" required="required" maxlength="11"/>
									</div>								
								<div class="clearfix">&nbsp;</div>
								<textarea class="subjects form-control" data-bind="value:description" placeholder="<?php echo lang('DESCRIPTION'); ?>" maxlength="255" style="max-width:100%; min-width:100%;"></textarea>
								</div>
							</div> 
						</form>
						<br/>
						<div class="ar">
							<div class="btn-group ar">
								<button data-bind="click:$parent.payment_save" class="btn btn-success"><i class="icon-save icon-white"></i>&nbsp;&nbsp;<?php echo lang('SAVE'); ?></button>
								<button class="btn btn-primary" data-dismiss="modal" name="cancel">
									<span class="icon-remove-sign icon-white"></span>
								</button>
								<br/>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="modal" id="e-mails" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-bind="with:emailPopUp">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
						<h4 class="modal-title"><?php echo lang('SEND'); ?></h4>
					</div>
					<div class="modal-body form-horizontal npb">
						<div class="form-group">
							<h5 class="col-md-1 control-label">To</h5>
							<div class="col-md-9">
								<input type="text" class="form-control" placeholder="Email_id" data-bind="value:email_to" />
							</div>
							<div class="col-md-2">
								<button class="btn btn-success" data-bind="click:send"><?php echo lang('SEND'); ?></button>
							</div>
						</div>
						<div class="form-group">
							<h5 class="col-md-1 control-label">Cc</h5>
							<div class="col-md-9">
								<input type="text" class="form-control" placeholder="" data-bind="value:email_cc">
							</div>
						</div>
						<div class="form-group">
							<div class="col-md-offset-1 col-md-10">
								<span class="pull-left icon icon-paperclip" style="color:#3A87AD">
									<a target="_blank" data-bind="attr:{href:email_url}">
										<span class="text-info" data-bind="text:email_file"></span>
									</a>
								</span>
							</div>
						</div>
						<div class="form-group">
							<label class="control-label"><?php echo lang('MESSAGE'); ?></label>
							<textarea class="form-control" rows="7" data-bind="value:email_message"></textarea>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div data-bind="visible:is_edit_mode, attr:{'class':(is_view_mode()==false&&is_edit_mode()==true)?'':'invoice page-slide col-lg-5 col-sm-12 col-xs-12 col-md-5 auto-height overflow-y'}" style="display:none;">
			<div id="view-layout"></div>
		</div>		
		<div class="page-slide col-xs-12 col-sm-7 col-md-6 col-lg-5 auto-height set_slider" data-bind="slideVisible:is_slide_modes()==true" style="display: none;background:none;border:0px;top:90px;right:0px;">
			<div id="project-invoice-container"></div>
		</div>
		<div class="page-slide col-lg-5 col-sm-12 col-xs-12 col-md-5 auto-height" data-bind="visible:isNewAdd()==1">
			<div id="addclient"></div>
		</div>
		<div id="comment_layout" class="page-slide fh col-lg-5 col-md-5" style="top:90px;" data-bind="visible:is_comment_mode"></div>
		<div class="pagination col-lg-12 text-center" data-bind="hidden:(is_edit_mode() || finish())" style="margin-top:-110px">
			<ul class="row" style="list-style:none;">
				<li>
					<a href="javascript:;" data-bind="hidden:finish, click:load_more" class="well"><?php echo lang('SHOW_MORE'); ?></a>
				</li>
			</ul>
		</div>
	</div>
</div>
<?php
	$jslang	= array();

	if (!$is_ajax_request)
	{
		$this->load->view("footer");
	}
?>
<script type="text/javascript">
$(document).ready(function(){
<?php
	$tmp	= array(
		'CONFIRM_PAY_FROM_DEPOSIT',
		'REIMPORT',
		'IMPORT_ITEMS_CONFIRM_MSG',
		'SELECT_DETAIL_HOURS',
		'SELECT_DETAIL_EXPENSES',
		'SELECT_PROJECTS',
		'CLIENT_DETAILS_REQUIRED',
		'INVALID_PRODUCT_SERVICE_ITEMS',
		'AMOUNT_MUST_BE_GREATER_THAN_ZERO',
		'PAYMENT_GREATER_THAN_BALANCE',
		'PAYMENT_MADE_FROM_DEPOSIT_INVOICE',
		'DELETE_CONFIRM',
		'NO_HRS_AVAIL_FOR_IMPORT',
		'UNARCHIVE',
		'ALL',
		'TODAY',
		'THIS_WEEK',
		'THIS_SEMI_MONTHLY',
		'THIS_MONTH',
		'THIS_QUARTER',
		'THIS_YEAR',
		'THIS_ACCOUNT_YEAR',
		'YESTERDAY',
		'LAST_WEEK',
		'LAST_SEMI_MONTHLY',
		'LAST_MONTH',
		'LAST_QUARTER',
		'LAST_YEAR',
		'LAST_ACCOUNT_YEAR',
		'INVALID_PRODUCT_SERVICE_DESC_NOT_EMPTY'
	);
	foreach ($tmp as $val)
	{
		$jslang[$val]	= lang($val);
	}
// 	echo '##' . $invoice_status . '##';exit;
?>
	Otime.Invoice.Clients	= <?php echo json_encode($clients); ?>;
	Otime.Invoice.Currency	= <?php echo json_encode($currency); ?>;
	Otime.Invoice.Status	= <?php echo json_encode($status); ?>;
	Otime.Invoice.due_date	= <?php echo json_encode($due_date_mode); ?>;
	Otime.Invoice.CurrCode	= "<?php echo $this->ot_app->get('currency_code'); ?>";
	Otime.Invoice.status_class	= <?php echo json_encode($this->config->config['status_class']); ?>;
	Otime.Invoice.filter_labels	= <?php echo json_encode(array_merge($date_filter_this, $date_filter_last)); ?>;
	Otime.Invoice.dft	= 'ALL'; // Date filter type
	Otime.Invoice.deposit	= Boolean(<?php echo (int)($view == "deposit"); ?>);
	Otime.Invoice.language	= <?php echo json_encode($jslang); ?>;
	Otime.Client.language		= <?php echo json_encode($jslang); ?>;

	Otime.Invoice.invoice_status	= '<?php echo empty($invoice_status) ? (is_admin()?"U":"D") : $invoice_status; ?>';
	Otime.Invoice.statusList	= <?php echo json_encode(empty($status_list)?array():$status_list); ?>;
	Otime.Invoice.IID	= '<?php echo empty($invoice_id) ? "0" : $invoice_id; ?>';

	window.Otime.load("Invoice");
});
$('#invoice_percent').click(function(){
	$('#percent_input').focus();
});
</script>
<div class="modal" id="timsheet_approve" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog" style="width:700px;">
		<div class="modal-content" data-bind="with:modTimesheet">
			<div class="modal-header">
				<button type="button" class="close" aria-hidden="true" data-bind="click:popup_close">&times;</button>
				<h4 class="modal-title" id="myModalLabel"><?php echo lang('TIME_SHEET_APPROVE');?></h4>
			</div>
			<div class="modal-body" style="min-height:150px"></div>
			 <div class="modal-footer">
			 	<h5  id="myModalLabel" data-bind="visible:unsubmitted() >0" style="text-align: right; margin-right: 25px; margin-top: 5px;"><?php echo lang('UNSUBMITTED_HOURS');?>&nbsp;<label data-bind="hours:{val:unsubmitted(), showNull:true}" class="label label-default fs-14 fw-normal"></label>&nbsp;<span class="sub-title"><?php echo lang('HRS'); ?></span></h5>
			 </div>
		</div>
	</div>
</div>
<div class="modal" id="expenses_approve" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog" style="width:900px;">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" aria-hidden="true" data-bind="click:popup_close">&times;</button>
				<h4 class="modal-title" id="myModalLabel"><?php echo lang('SUBMITTED_FOR_APPROVAL'); ?></h4>
			</div>
			<div class="modal-body"></div>
		</div>
	</div>
</div>
<div class="modal" id="approved_hours" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog" style="width:700px;">
		<div class="modal-content" data-bind="with:modApprove">
			<div class="modal-header">
				<button type="button" class="close" aria-hidden="true" data-bind="click:popup_close">&times;</button>
				<h4 class="modal-title" id="myModalLabel"><span data-bind="text:project_name"></span><span class="pull-right" data-bind="text:date_disp"></span></h4>
			</div>
			<div class="modal-body" style="min-height:150px">
				<table class="team-table team-table-day day-view table table-hover" data-bind="visible:listing().length>0">
					<tbody data-bind="foreach:listing">
						<!-- ko if:$index() == 0 -->
						<tr class="nbt">
							<td><input class="nmt" type="checkbox" data-bind="checked:$parent.check_all"/>&nbsp;Check all&nbsp; </td>
							<td class="ar cp">
								<span class="label label-success title cp" data-bind="click:$parent.update_billable"><?php echo lang('MARK_AS_BILLED'); ?></span>
							</td>
						</tr>
						<!-- /ko -->
						<tr class="user">
							<td>
								<input class="nmt" type="checkbox" data-bind="checked:is_checked"/>
								<img src="" data-bind="img:user_image, attr:{title:user_name}" class="img32x32" />
								<span data-bind="text:user_name"></span>
							</td>
							<td data-bind="hours:{val:hours, showNull:true}, click:$root.show_details" class="ar cp day" style="padding:7px;"></td>
						</tr>
						<!-- ko foreach:details -->
						<tr class="timesheet">
							<td style="padding-left:20px;"><input class="nmt" type="checkbox" data-bind="checked:is_checked"/>&nbsp;<span data-bind="html:task_type"></span></td>
							<td data-bind="html:hours" class="ar cp" style="padding:7px;">				
							</td>
						</tr>
						<!-- /ko -->
					</tbody>
				</table>
				<div class="text-center" data-bind="visible:listing().length<1" style="margin-top: 50px;">
					<span class="well"><?php echo lang('NO_NON_BILLABLE'); ?></span>
				</div>
			</div>
		</div>
	</div>
</div>
<iframe style="display:none" id="iframe_download" src="about:blank" target="_blank"></iframe>
