<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$is_ajax_request	= $this->input->is_ajax_request();

	if (!$is_ajax_request)
	{
		$this->load->view("header");
	}
	$fields	= array(
		'form_open'		=> array(
			'id'			=> 'user_form',
			'name'			=> 'user_form',
			'class'			=> 'form-horizontal',
			'onsubmit'		=> 'return false;',
		),
		'first_name'	=> array(
			'id'			=> 'first_name',
			'name'			=> 'first_name',
			'class'			=> 'col-lg-12 form-control form-group',
			'data-bind'		=> 'value:first_name',
			'placeholder'	=> lang('FIRST_NAME'),
			'maxlength'	=> '30',
		),
		'last_name'	=> array(
			'id'			=> 'last_name',
			'name'			=> 'last_name',
			'class'			=> 'col-lg-12 form-control form-group',
			'data-bind'		=> 'value:last_name',
			'placeholder'	=> lang('LAST_NAME'),
			'maxlength'	=> '30',
		),
		'email'	=> array(
			'id'			=> 'email',
			'name'			=> 'email',
			'class'			=> 'col-lg-12 form-control form-group',
			'data-bind'		=> 'value:email',
			'placeholder'	=> lang('EMAIL'),
			'type'			=> 'email',
		),
		'hourly_rate'	=> array(
			'id'			=> 'hourly_rate',
			'name'			=> 'hourly_rate',
			'class'			=> 'col-lg-10 form-control',
			'data-bind'		=> 'value:hourly_rate',
			'placeholder'	=> lang('HOURLY_RATE'),
		),		
		'department'	=> array(
			'id'			=> 'department',
			'name'			=> 'department',
			'class'			=> 'col-lg-12 form-control form-group',
			'data-bind'		=> 'value:department',
			'placeholder'	=> lang('DEPARTMENT'),
		),
		'password'		=> array(
			'class'			=> 'form-control input-md',
			'name'			=> 'password',
			'id'			=> 'password',
			'placeholder'	=> 'Password',
			'minlength'		=> '6',
			'maxlength'		=> '12',
			'data-bind'		=> 'value:password, valueUpdate:\'afterkeydown\'',
		),
		'confirm_password'		=> array(
			'class'			=> 'form-control input-md',
			'name'			=> 'confirm_password',
			'id'			=> 'confirm_password',
			'placeholder'	=> 'Confirm Password',
			'minlength'		=> '6',
			'maxlength'		=> '12',
			'data-bind'		=> 'value:confirm_password, visible:password().length',
		),
	);
	$hidden	= array('user_id');
?>
<div id="body-container">
	<div id="page-container">
		<div id="profile-container" style="margin-top: 40px;">
			<div class="page-header-bar">
			  <div id="alert_message" class="ac col-md-9 fix-it"></div>
		      <span class="title">Profile</span>
	        </div>        
			<div id="user-edit" class="col-lg-7">
				<div class="pull-left col-lg-3 ac">
					<span class="dib">
						<div id="company_browse">
							<i class="delete pull-right icon-remove cp" id="removeImage" data-bind="click:removeImage, visible:user_image()!=''"></i>
							<div class="img-thumbnail cp">
								<div data-bind="click:uploadDialog" style="height:120px;width:120px;overflow:hidden;">
									<img id="target-prof-img" data-bind="attr:{title:first_name}, img:user_image_path" rel="tooltip" style="width:100%;" />
									<img data-bind="img:oldImage" style="display:none;" />
								</div>
							</div>
							<input type="file" data-bind="value:profile_image" id="profile_image" name="profile_image" class="fileUpload" />
						</div>
						<!-- <img class="thumb-img" data-bind="attr:{src:user_image}" src="<?php echo base_url('files/photo/noUser.png'); ?>" /> -->
					</span>
					</br>
					<h4 data-bind="text:user_role_disp"></h4>
				</div>
				<div class="col-lg-8 pull-left">
					<div class="row">
						<span class="col-lg-6 np">
							<?php echo form_input($fields['first_name']); ?>
						</span>
					    <span class="col-lg-6 npr">
							<?php echo form_input($fields['last_name']); ?>
						</span>
					</div>
					<span class="clear sep"></span>
					<div class="row">
						<?php echo form_input($fields['email']); ?>
             		</div>
					<div class="row">
						<select class="select form-control" data-bind="value:time_zone_code, chosen:true">
							<?php foreach (timezones() as $key=>$val): ?>
							<option value="<?php echo $key; ?>"><?php echo lang($key); ?></option>
							<?php endforeach; ?>
						</select>
					</div>
					<div class="sep">&nbsp;</div>
					<div class="row">
						<div class="input-group">
							<span class="input-group-addon">
								<span class="icon-lock"></span>
							</span>
							<?php echo form_password($fields['password']); ?>
						</div>
					</div>
					<div class="sep">&nbsp;</div>
					<div class="row" data-bind="visible:password().length">
						<div class="input-group">
							<span class="input-group-addon">
								<span class="icon-lock"></span>
							</span>
							<?php echo form_password($fields['confirm_password']); ?>
						</div>
					</div>
					<div class="sep">&nbsp;</div>
					<div class="row">
						<!-- <label class="col-md-12"><?php echo lang('EMAIL_SUBSCRIPTION'); ?></label> -->
						<?php /* if (is_admin()): ?>
						<div class="col-md-6">							
							<div class="checkbox"><label><input type="checkbox" data-bind="checked:is_weekly_mail" name="mail_type" value="<?php echo 'W'; ?>"><?php echo lang('WEEKLY_MAIL'); ?></label></div>
						</div>
						<?php endif; */ ?>
						<div class="col-md-6">
							<div class="checkbox"><label><input type="checkbox" data-bind="checked:is_weekly_summary_mail" name="mail_type" value="<?php echo 'WS'; ?>"><?php echo lang('WEEK_SUMMARY_MAIL'); ?></label></div>
						</div>
						<div class="col-md-6">
							<div class="checkbox"><label><input type="checkbox" data-bind="checked:enable_notification" name="enable_notification"><?php echo lang('BROWSER_NOTIFICATION'); ?></label></div>
						</div>
					</div>
					<div class="clearfix">&nbsp;</div>
					<div class="row btn-group pull-right">
						<button data-bind="click:save" class="btn btn-success btn-sm"><?php echo lang('SAVE'); ?></button>
						<!-- <button class="btn btn-primary btn-sm" data-bind="click:cancel" name="cancel">
								<span class="icon-remove-sign icon-white"></span>
						</button> -->
					</div>
					<div class="clearfix">&nbsp;</div><br>
				</div>
				<div class="clearfix">&nbsp;</div>
			</div>
			<div class="modal" id="crop_image" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
							<h4 class="modal-title"><?php echo lang('SET_AS_PROFILE_PHOTO'); ?></h4>
						</div>
						<div class="modal-body form-horizontal dib">
							<img data-bind="img:user_image_path" id="target" />
							<div id="preview-pane">
								<div class="preview-container">
									<img data-bind="img:user_image_path" class="jcrop-preview" alt="Preview" />
								</div>
								<div class="clearfix">&nbsp;</div>
								<button class="btn btn-success" data-bind="click:cropApply"><?php echo lang('APPLY'); ?></button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<!-- ko if:user_id()>0 -->
			<div id="projects-list" class="col-lg-5">
				<div class="panel panel-primary nmb">
					<div class="panel-heading clearfix">
						<div class="pull-left total-bg">
							<h2 data-bind="text:_project.total_projects" class="col-md-1"></h2>
						</div>
						<div class="col-md-5 col-xs-5">								
							<h4 class="modal-title"><?php echo lang('PROJECTS'); ?></h4>
							<div>
							<div class="pull-left">
								<h3 data-bind="text:_project.active_projects" class="nm"></h3>
								<span><h6 class="modal-title"><?php echo lang('ACTIVE'); ?></h6></span>
							</div>
						    <div class="pull-left vertical-line">
								<h4 data-bind="text:_project.in_active_projects"></h4>
							</div>
						</div>
						</div>
						<div class="pull-right">
							<div class="row nmr">
								<span class="pull-left"><h2 data-bind="hours:{val:_project.total_hours, showNull:true}" class="list-group-item-heading"></h2></span>
								<span class="pull-right hrs"><?php echo lang('HRS'); ?></span>
						    </div>
						    <div class="row"><hr class="modal-title col-md-7 nm"></div>
							<div class="row nmr">
								<div class="pull-left"><?php echo lang('BILLABLE'); ?></div>
								<div class="pull-right">
									<h4 data-bind="hours:{val:_project.billable, showNull:true}" class="nm np al"></h4>
								</div>
							</div>
					    </div>
  					</div>
				</div>
			 	<div class="timeline">
			        <div  data-bind="foreach:_project.items">
						<div class="row block">
					   		<span class="icon-list-alt icon-metro img-circle bg-blue nb"></span>
							<div class="well nm">
								<div class="row nm">
									<div class="pull-left">
										<h4 class="no-margin" data-bind="text:project_name"></h4>
										<h6 data-bind="text:client_name" class="small gray"></h6>
									</div>
									<div class="pull-right align-right">
										<h4 data-bind="hours:{val:hours, showNull:true}" class="pull-left normal no-margin"></h4>&nbsp;
										<span style="font-weight:600;"><?php echo lang('HRS'); ?></span>
										<div class="clearfix"></div>
										<h6 data-bind="text:date" class="small gray"></h6>
									</div>	
								</div>
							</div>
						</div>
				    </div>
					<div class="row">
						<span class="label btn-success">
						<!-- ko if: _project.view_more -->
						<a  id="view_more_projects" href="javascript:;" data-bind="click:load_more_projects"><span class="btn-success"><?php echo lang('VIEW_MORE'); ?></span></a>
						<!-- /ko -->
						<!-- ko if: _project.loading -->
						<a href="javascript:;"><span class="btn-success"><?php echo lang('LOADING'); ?></span></a>
						<!-- /ko -->
						<!-- ko if: _project.view_more()==false && _project.loading()==false -->
						<a href="javascript:;">
							<span class="btn-success adc" data-bind="visible:_project.total_projects()>0"><?php echo lang('NO_MORE_DATA'); ?></span>
							<span class="btn-success adc" data-bind="visible:_project.total_projects()<=0"><?php echo lang('NO_DATA_FOUND'); ?></span></a>
						<!-- /ko -->
						</span>
					</div>
				</div>
			</div>
		<!-- /ko -->
		</div>
	</div>
</div>
<?php
	$jslang	= array();
	$tmp	= array('PROFILE_SAVE_SUCCESS', 'INVALID_EMAIL', 'LOCK_THIS_USER', 'UNLOCK_THIS_USER','CONFIRM_DELETE_USER','ERR_PRIMARY_DATA_MISSING', 'CONFIRM_RESET_PASSWORD');
	foreach ($tmp as $val)
	{
		$jslang[$val]	= lang($val);
	}
	$jslang['FIRST_NAME_REQUIRED']	= lang('FIELD_REQUIRED', lang('FIRST_NAME'));
	$jslang['SELECT_USER_ROLE']	= lang('FIELD_REQUIRED', lang('USER_ROLE'));
	$jslang['DEPARTMENT_REQUIRED']	= lang('FIELD_REQUIRED', lang('DEPARTMENT'));
	$jslang['HOURLY_RATE_REQUIRED']	= lang('FIELD_REQUIRED', lang('HOURLY_RATE')); 

	if (!$is_ajax_request)
	{
		$this->load->view("footer");
	}
?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.Profile.user_roles	= <?php echo json_encode($user_role); ?>;
		Otime.Profile.language	= <?php echo json_encode($jslang); ?>;
		Otime.Profile.entity_id	= '<?php echo $this->ot_app->get('entity_id'); ?>';
		window.Otime.load("Profile");
	});
</script>
