﻿(function(Otime) {

	Otime.Addons	= new function Addons(){
//		"use strict";

		var _this	= this;

		_this.name	= "addons";

		_this.model	= "AddonsListModel";

		_this.language	= null;

		_this.CID	= 0;

		/*_this.addNew	= function(){
			_this.listModel.addItem();
		};*/

		_this.AddonsListModel	= function(data){
			var self	= this;

			data	= data || {};
			self.items	= Otime.a([]);

			self.show_loading	= Otime.o(false);
			self.loading		= Otime.o(false);
			self.selectedItem	= Otime.o(null);
			self.is_edit_mode	= Otime.o(false);
			self.popupItem		= Otime.o(null);

			self.refresh	= function(active){
				Otime.app.postData(new Otime.ContextModel({
					url: "listing",
					data: {},
					callback: function(cont){
						var resp	= cont.response,
							flag0	= false;
						if (resp.items && resp.items.otvalues && resp.items.otvalues.length>0)
						{
							var tmpArr	= [],
								tmpModel	= null;
							resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
								tmpModel	= new _this.AddonContentModel(itm, self);
								tmpArr.push(tmpModel);
							});
							self.items(tmpArr);
						}
					}
				}));
				return true;
			};
			
			self.cancel	= function(){
				self.is_edit_mode(false);
				Otime.Menu.loadURL("settings");
			}

			self.configEdit	= function(item, elem){
				if (!item.app_id())
				{
					return false;
				}
				self.selectedItem(item);
				self.is_edit_mode(true);

				if (!Otime.app.hasBinding(_this.edit_container))
				{
					Otime.app.load_template("edit", function(response){
						_this.edit_container.html($.trim(response));

						if (self.popupItem() == null)
						{
							self.popupItem(new _this.AddonContentModel(null, self));
						}

						ko.applyBindings({popupitem:self.popupItem}, _this.edit_container.get(0));
						self.configEdit(item, elem);
					});
					return false;
				}

				// Otime.Menu.ReplaceURL(_this.name + "/" + item.app_id());
				Otime.app.loadData(new Otime.ContextModel({
					url: "edit/" + item.app_id(),
					global: false,
					callback: function(cont){
						self.load(cont);
					},
					params: "EDIT"
				}));
			};



			self.load	= function(context){
				var src	= self.selectedItem();
				var data	= context.response || {};
				var newItem	= new _this.AddonContentModel(null, self);

				if (data)
				{
					var events = data.events || {};
					var config_fields = data.config_fields || {};
					data = data.items || {};
					data = data[0] || {};

					newItem.app_id(data.app_id || 0);
					newItem.app_name(data.app_name || "");
					newItem.developed_by(data.developed_by || "");
					newItem.app_description(data.app_description || "");
					newItem.is_internal(data.is_internal || 1);
					newItem.category_code(data.category_code || "");
					newItem.app_image(($.trim(data.app_image) != "") ? (_this.IMG + data.app_image):"");
					newItem.is_enabled(data.is_enabled || 0);

					newItem.auth_key_name(data.auth_key_name || "Auth key");
					newItem.auth_key_value(data.auth_key_value || "");
					newItem.server_name(data.server_name || "");
					var active_events = data.active_events?JSON.parse(data.active_events):[];
					if (events) {
						var tmpArr = [];
						events	= events.otvalues.setKeys(events.otkeys, function(event){
							
							tmpArr.push({
								event_code: event.event_code,
								event_name: event.event_name?event.event_name:event.event_code,
								is_checked : Otime.o((active_events.indexOf(event.event_code)!=-1 ?true:false))
							});
						});
						newItem.events(tmpArr);
					}
				}
				// if (data.config_value)
				// {
				data.config_value	= data.config_value?JSON.parse(data.config_value):[];
//				}
				var rand = "conf_tmpl_";
				if (Object.keys(config_fields).length) {
					tmpArr = [];
					// + new Date().getTime();
					var script = "";
					var tmpObj	= {};
					$.each(config_fields, function(key, val){
						tmpObj[key]	= Otime.o(data.config_value[key] || val.value || "");
						script	+= val.html;
					});
					newItem.config_fields(tmpObj);
					if (!$('#'+rand).length) {
						script	= "<script id='" + rand + "' type='text/html'>"+ script +"</script>";
						$(script).appendTo("body");				
					} else {
						$('#'+rand).html(script);
					}
					newItem.config_fields_tmpl(rand);
				} else {
					if($('#'+rand)) $('#'+rand).html('');
				}

				self.is_edit_mode(true);
				self.popupItem(newItem);
				return newItem;
			};
		};

		_this.prepareData	= function(self){
			var active_events = [];
			if (self.events().length>0) {
				$.each(self.events(), function(key, val){
					if (val.is_checked()) {
						active_events.push(val.event_code)
					}
				});
			}
			var data	= {auth_key_value:self.auth_key_value, app_id:self.app_id(),server_name:self.server_name()};
			if (Object.keys(self.config_fields()).length)
			{
				data.config_value	= ko.toJSON(self.config_fields);
			}
			data.active_events = active_events.length?JSON.stringify(active_events):'';
			return data;
		};

		_this.Save	= function(){
			var targetItem	= _this.listModel.popupItem();

			if (!targetItem.app_id())
			{
				return false;
			}

			var postData	= _this.prepareData(targetItem);

			Otime.app.postData(new Otime.ContextModel({
				url: "save",
				data: postData,
				callback: function(cont){
					var response = cont.response;
					var srcItem	= _this.listModel.popupItem();

					// srcItem.commit();
					srcItem.swapMode();
				}
			}));
		};
		
		_this.AddonContentModel	= function(data, parent){
			var self	= this;

			data = data || {};

			var language			= data.language || _this.language;
			self.app_id 			= Otime.o(data.app_id || 0);
			self.app_name			= Otime.o(data.app_name || "");
			self.developed_by		= Otime.o(data.developed_by || "");
			self.app_description	= Otime.o(data.app_description || "");
			self.is_internal		= Otime.o(data.is_internal || 1);
			self.config_fields		= Otime.o({});
			self.category_code		= Otime.o(data.category_code || "");
			self.app_image			= Otime.o(($.trim(data.app_image) != "") ? (_this.IMG + data.app_image):"");
			self.is_enabled			= Otime.o(data.is_enabled || 0);
			self.config_fields_tmpl	= Otime.o("");
			
			self.auth_key_name		= Otime.o(data.auth_key_name || "Auth key");
			self.auth_key_value		= Otime.o(data.auth_key_value || "");
			self.server_name		= Otime.o(data.server_name || "");
			self.events				= Otime.a([]);

			self.change_status = function() {
				var data = {};
				data.app_id 	= this.app_id();
				var fun 		= (this.is_enabled()==0)?'enable':'disable';
				
				Otime.app.postData(new Otime.ContextModel(fun, data, function(resp){
					resp	= resp.response;
					self.is_enabled(resp.is_enabled);
					/*if (self.is_enabled()) {
						parent.configEdit(self);
					}*/
				}));
			}

			self.save	= _this.Save;

			self.cancel	= function(item){
				self.rollback && self.rollback();
				self.swapMode();
				Otime.Menu.ReplaceURL(_this.name);
			};

			self.swapMode	= function() {
				parent.is_edit_mode(false);
				parent.selectedItem(new _this.AddonContentModel());
				Otime.Menu.ReplaceURL(_this.name);
			};
		};
		
		_this.UpdateContainers	= function(){
			_this.addons_container	= $("#addons-container");
			_this.list_container	= $("#list-container");
			_this.edit_container	= $("#edit_layout");
		};

		_this.init	= function(){
			_this.UpdateContainers();
			Otime.unbind();

			_this.list_container.masonry({ itemSelector: '.metro-item', columnWidth: 0 });
			_this.listModel	= new _this.AddonsListModel();
			_this.listModel.refresh();
			ko.applyBindings(_this.listModel, _this.addons_container.get(0));

		};
	};

}(window.Otime));
