﻿(function(Otime){

	Otime.TimeSheetApprove	= new function(){
//		"use strict";

		var _this	= this;

		_this.name	= "timesheet";

		_this.model	= "TimesheetApproveModel";

		_this.language	= null;

		// Status approved
		_this.SA	= "A";

		// Status submited
		_this.SS	= "S";

		var isPresent	= false;

		_this.TimesheetApproveModel	= function(data){
			var self	= this;

			data	= data || {};

			self._info	= {};

			if (typeof data.popup_close == "function")
			{
				self.popup_close	= data.popup_close;
			}

			self.today	= new Date();

			self.current_date	= Otime.o(self.today);

			self.show_nodata	= Otime.o(false);
			self.listing	= Otime.a([]);
			self.users	= Otime.a([]);

			self.is_allow	= Otime.o(false);
			self.is_open	= Otime.o(false);
			self.hours		= Otime.o('');

			// search
			self.projects	= Otime.a([]);
			self.proj_value	= Otime.o(["0"]);
			self.task_types	= Otime.a([]);
			self.task_type_value	= Otime.o(["0"]);
			self.billable	= Otime.o('');
			self.unsubmitted	= Otime.o(0);

			var ret		= false,
				oldVal	= [];
			self.proj_value.subscribe(function(oldValue){
				oldVal	= oldValue;
			}, null, "beforeChange");
			self.proj_value.subscribe(function(newVal){
				if (ret)
				{
					ret	= false;
					self.loadInfo();
					return true;
				}
				if (newVal.length <= 0)
				{
					ret	= true;
					self.proj_value(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					ret	= true;
					if (oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.proj_value(newVal);
						return true;
					}
					self.proj_value(["0"]);
					return true;
				}
				self.loadInfo();
			});

			var ret = false, oldVal	= [];
			self.task_type_value.subscribe(function(oldValue){
				oldVal	= oldValue;
			}, null, "beforeChange");
			self.task_type_value.subscribe(function(newVal){
				if (ret)
				{
					ret	= false;
					self.loadInfo();
					return true;
				}
				if (newVal.length <= 0)
				{
					ret	= true;
					self.task_type_value(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					ret	= true;
					if (oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.task_type_value(newVal);
						return true;
					}
					self.task_type_value(["0"]);
					return true;
				}
				self.loadInfo();
			});

			self.swap_view	= function(){
				Otime.Menu.loadURL("timesheet/revoke");
			};

			self.prev	= function(item){
				isPresent	= true;
				item._info.current_date(new Date(item._info.current_date()).addDays(-7));
//				self.loadTimeInfo();
			};

			self.next	= function(item){
				isPresent	= true;
				item._info.current_date(new Date(item._info.current_date()).addDays(7));
//				self.loadTimeInfo();
			};

			var toolTipTmplI	= "<h5 class=\"nmb\">##PROJECT_TASK_NAME##</h5>";
				toolTipTmplI	+= "<h5>##PROJECT_NAME## - ##TASK_TYPE_NAME##</h5>##NOTES##";
//				toolTipTmplI	+= "<h5></h5>##NOTES##";
			var notesTmplI	= "<small>##NOTES##</small>";
			self.getToolTipI	= function(item){
				var _tmpl	= toolTipTmplI + "",
					_pname	= item.project_name();

				if (item.project_code())
				{
					_pname	= item.project_code() + "-" + item.project_name();
				}

				_tmpl	= _tmpl.replace('##PROJECT_NAME##', _pname);
				_tmpl	= _tmpl.replace('##PROJECT_TASK_NAME##', item.project_task_name());
				_tmpl	= _tmpl.replace('##TASK_TYPE_NAME##', item.task_type_name());
				if (item.notes && item.notes())
				{
					_tmpl	= _tmpl.replace('##NOTES##', notesTmplI.replace('##NOTES##', item.notes()));
				}
				else
				{
					_tmpl	= _tmpl.replace('##NOTES##', '');
				}

				return _tmpl;
			};

			var toolTipTmplD	=  "Approved By\t: ##APPROVED_BY##.\n";
				toolTipTmplD	+= "Approved On\t: ##APPROVED_DATE##.";
			self.getToolTipD	= function(item){
				if (!item.is_approved() || !item.hours())
				{
					return false;
				}

				var _tmpl	= toolTipTmplD + "";
				_tmpl	= _tmpl.replace('##APPROVED_BY##', Object.values(item.approved_by()).join(",\n\t\t\t\t: "));
				_tmpl	= _tmpl.replace('##APPROVED_DATE##', item.approved_date());

				return _tmpl;
			};

			self.loadInfo	= function(){
				self.show_nodata(false);
				var data	= {
					project_id: self.proj_value(),
					task_type_id: self.task_type_value()
				};

				if (data.project_id.length <= 0 || Number(data.project_id[0]) <= 0)
				{
					delete data.project_id;
				}

				if (data.task_type_id.length <= 0 || Number(data.task_type_id[0]) <= 0)
				{
					delete data.task_type_id;
				}

				Otime.app.loadData(new Otime.ContextModel('project_timesheet', data, self.load));
			};

			self.load	= function(context){
				var data	= context.response || {};

				self.unsubmitted(data.unsubmitted || 0);

				if (data.approvable_users != undefined && Object.keys(data.approvable_users).length==2 && data.approvable_users.otvalues.length > 0)
				{
					data.approvable_users	= data.approvable_users.otvalues.setKeys(data.approvable_users.otkeys, null, "user_id");
					_this.approvableUsers	= data.approvable_users;
				}
				if (data.filters)
				{
					var prj_ids = data.filters.project_id;
					if (!(data.filters.project_id instanceof Array))
					{
						prj_ids = [data.filters.project_id];
					}

//					self.proj_value(prj_ids || self.proj_value());
//					self.task_type_value(data.filters.task_type_value || self.task_type_value());
					self.billable(data.filters.billable || self.billable());
				}
				var lstData	= [];
				if (data.items != undefined && Object.keys(data.items).length==2 && data.items.otvalues.length > 0)
				{
					data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
						val.hours	= parseFloat(val.hours).toFixed(2);
						lstData.push(new _this.UserListModel(val));
					});
				}
				self.listing(lstData);
				self.show_nodata	= Otime.o(true);
			};

			var prepare_data	= function (){
				var post_data	= {};
				if (Number(self.proj_value()[0]))
					post_data.project_id	= self.proj_value();

				if (Number(self.task_type_value()[0]))
					post_data.task_type_id	= self.task_type_value();

				return post_data;
			};

			self.approve_week	= function(item){
				var url	= Otime.siteUrl + "/" + _this.name +'/approve_timesheet';
				var post_data	= $.extend({
					user_id: item.user_id(),
					from_date: item._info.from_date().format(Otime.sdf),
					to_date: item._info.to_date().format(Otime.sdf)
				}, prepare_data());

				Otime.app.postData(new Otime.ContextModel(url, post_data, function(cont){
					var resp	= cont.response.user_data;
					if (!resp)
					{
						self.listing.remove(item);
						return true;
					}
					item.user_hours(resp.hours-0);
					if (isPresent)
					{
						self.loadTimeInfo(userData);
						return true;
					}
					item.to_date(Otime.Date(resp.to_date));
					item.from_date(Otime.Date(resp.from_date));
				}), true);
				return true;
			};

			self.reject_week	= function(item){
				if (!confirm("Are you sure you want to reject."))
				{
					return false;
				}

				var url	= Otime.siteUrl + "/" + _this.name +'/reject_timesheet';
				var post_data	= $.extend({
					user_id: item.user_id(),
					from_date: item._info.from_date().format(Otime.sdf),
					to_date: item._info.to_date().format(Otime.sdf)
				}, prepare_data());

				Otime.app.postData(new Otime.ContextModel(url, post_data, function(cont){
					var resp	= cont.response.user_data;
					if (!resp)
					{
						self.listing.remove(item);
						return true;
					}
					item.user_hours(resp.hours-0);
					if (isPresent)
					{
						self.loadTimeInfo(userData);
						return true;
					}
					item.to_date(Otime.Date(resp.to_date));
					item.from_date(Otime.Date(resp.from_date));
				}), true); 
				return true;
			};

			self.approveDayEntry	= function(userData){
				return function(item){
					var url	= Otime.siteUrl + "/" + _this.name +'/approve_timesheet';
					var post_data	= $.extend({
						user_id: userData.user_id(),
						from_date: item.entry_date
					}, prepare_data());
					Otime.app.postData(new Otime.ContextModel(url, post_data, function(cont){
						var resp	= cont.response.user_data;
						if (!resp)
						{
							self.listing.remove(userData);
							return true;
						}
						userData.user_hours(resp.hours-0);
						if (isPresent)
						{
							self.loadTimeInfo(userData);
							return true;
						}

						var itms	= userData.items();
						userData.to_date(Otime.Date(resp.to_date));
						userData.from_date(Otime.Date(resp.from_date));
					}), true);
					return true;
				};
			};

			self.rejectDayEntry	= function(userData){
				return function(item){
					if (!confirm("Are you sure you want to reject."))
					{
						return false;
					}

					var url	= Otime.siteUrl + "/" + _this.name +'/reject_timesheet';
					var post_data	= $.extend({
						user_id: userData.user_id(),
						from_date: item.entry_date
					}, prepare_data());
					Otime.app.postData(new Otime.ContextModel(url, post_data, function(cont){
						var resp	= cont.response.user_data;
						if (!resp)
						{
							self.listing.remove(userData);
							return true;
						}

						userData.user_hours(resp.hours-0);
						if (isPresent)
						{
							self.loadTimeInfo(userData);
							return true;
						}
						userData.to_date(Otime.Date(resp.to_date));
						userData.from_date(Otime.Date(resp.from_date));
					}), true); 
					return true;
				};
			};

			self.approveList	= function(item){
				var url	= Otime.siteUrl + "/" + _this.name +'/approve_timesheet';

				var post_data	= prepare_data(item);
				post_data.user_id	= item.user_id();

				Otime.app.postData(new Otime.ContextModel(url,  post_data, function(cont){
					var data	= cont.response || {};
					if(data)
						self.listing.remove(item);
				}), true);

				return true;
			};

			self.rejectList	= function(item){
				if (!confirm("Are you sure you want to reject."))
				{
					return false;
				}

				var url	= Otime.siteUrl + "/" + _this.name +'/reject_timesheet';

				var post_data	= prepare_data(item);
				post_data.user_id	= item.user_id();

				Otime.app.postData(new Otime.ContextModel(url,  post_data, function(cont){
					var data	= cont.response || {};
					if(data)
						self.listing.remove(item);
				}), true);

				return true;
			};

			self.selectedItem	= Otime.o(null);
			self.loadTimeList = function(item){
				self.selectedItem(item);
				if (item.is_open())
				{
					item.is_open(false);
				}
				else
				{
					$.each(self.listing(), function(lkey, lvalue){
						lvalue.is_open(false);
					});
					self.loadTimeInfo(item);
				}
			};

			self.loadTimeInfo	= function(item){
				item	= self.selectedItem();

				var data	= {
					user_id: item.user_id(),
					project_id: self.proj_value(),
					task_type_id: self.task_type_value(),
					from_date: item._info.from_date().format(Otime.sdf),
					to_date: item._info.to_date().format(Otime.sdf)
				};

				if (data.project_id.length <= 0 || Number(data.project_id[0]) <= 0)
				{
					delete data.project_id;
				}
				if (data.task_type_id.length <= 0 || Number(data.task_type_id[0]) <= 0)
				{
					delete data.task_type_id;
				}

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/" + _this.name +'/project_timesheet_user', data, function(cont){
					var resp	= cont.response || {};

					var days	= {};
					var tmpDate	= new Date(item._info.from_date());

					for (var i=0; i<7; i++)
					{
						days[tmpDate.format(Otime.sdf)]	= new _this.DayModel({
							date: tmpDate,
							hours: 0
						});
						tmpDate	= tmpDate.addDays(1);
					}

					var key	= "",
						rows	= {},
						rowsIsApproved	= {},
						total_hours	= 0;
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{
						var tmpObj	= null;
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
							itm.hours	= (itm.hours-0).toFixed(2)-0;
							days[itm.entry_date].hours((days[itm.entry_date].hours() + itm.hours).toFixed(2)-0);

							tmpObj	= days[itm.entry_date].approved_by();
							tmpObj[itm.approved_by]	= tmpObj[itm.approved_by] || (_this.approvableUsers[itm.approved_by] || {}).first_name || "";
							days[itm.entry_date].approved_by(tmpObj);
							days[itm.entry_date].approved_date(Otime.Date(itm.approved_date).format(Otime.dateFormat));

							key	= itm.project_id + "_" + itm.task_type_id + "_" + itm.project_task_name.hashCode();

							if (rows[key])
							{
								var tmp	= rows[key].hours_list();

								if (tmp[itm.entry_date])
								{
									tmp[itm.entry_date]	+= itm.hours;
								}
								else
								{
									tmp[itm.entry_date]	= itm.hours;
								}
								rows[key].hours_list(tmp);
								rows[key].total_hours(rows[key].total_hours() + itm.hours);

								rows[key].is_approved(rows[key].is_approved() && itm.approval_status == _this.SA);
								rowsIsApproved[key][itm.entry_date]	= (itm.approval_status == _this.SA);
							}
							else
							{
								rows[key]	= new _this.TimeContentModel(itm);
								rowsIsApproved[key]	= {};
								rowsIsApproved[key][itm.entry_date]	= rows[key].is_approved();
							}
//console.log(itm.hours, itm.entry_date, days[itm.entry_date].is_approved(), rowsIsApproved[key][itm.entry_date]);
							days[itm.entry_date].is_approved(days[itm.entry_date].is_approved() && rowsIsApproved[key][itm.entry_date]);

							if (!days[itm.entry_date].is_approved())
								total_hours	+= itm.hours;
						});
					}

					item.days(days);

					item.tot_week_hours(total_hours.toFixed(2));
					item.items(Object.values(rows));
					item.is_open(true);
				}), true);
				return true;
			};
		};

		_this.DayModel	= function(data){
			var self	= this;

			data	= data || {};

			self.date		= Otime.o(data.date || new Date());
			self.day_name	= Otime.o(self.date().format("DDD"));
			self.day_value	= Otime.o(self.date().format("DD"));
			self.hours		= Otime.o(data.hours-0);
			self.is_current	= Otime.o(self.date().isToday());
			self.is_leave	= Otime.o(self.date().isLeave());
			self.is_approved	= Otime.o(data.is_approved===false?false:true);
			self.approved_by	= Otime.a(data.approved_by || []);
			self.approved_date	= Otime.o(data.approved_date);

			self.entry_date	= self.date().format(Otime.sdf);
		};

		_this.TimeContentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.project_code	= Otime.o(data.project_code || "");
			self.project_name	= Otime.o(data.project_name || "");
			self.task_type_name	= Otime.o(data.task_type_name || "");
			self.project_task_name	= Otime.o(data.project_task_name || "");
			self.timesheet_hours	= Otime.o(data.hours-0 || 0);
			self.entry_date		= Otime.o(data.entry_date || "");
			self.is_approved	= Otime.o(data.approval_status == _this.SA);

			self.total_hours	= Otime.o(data.hours-0 || 0);

			var lst		= {};
			lst[self.entry_date()]	= data.hours-0;
			self.hours_list		= Otime.o(lst);
		};

		_this.UserListModel	= function(data){
			var self	= this;
			data		= data || {};
			
			if(data.user_image)
			{
				data.user_image = Otime.UMIP + data.user_image;
			}

			self._info	= {};

			self.timesheet_id	= Otime.o(data.timesheet_id || 0);
			self.user_id		= Otime.o(data.user_id || 0);
			self.first_name		= Otime.o(data.first_name || "");
			self.last_name		= Otime.o(data.last_name || "");
			self.user_image		= Otime.o(data.user_image || Otime.baseUrl + 'assets/img/no_Img_32.png');

			self._info.current_date	= Otime.o(null);

			self.from_date	= Otime.o();
			self.from_date_format	= Otime.o();
			self.from_date.subscribe(function(newVal){
				newVal	= new Date(newVal);
				self.from_date_format(newVal.format(Otime.dateFormat));
				self._info.current_date(newVal);
			});
			self.from_date(Otime.Date(data.from_date));

			self.to_date	= Otime.o();
			self.to_date_format		= Otime.o();
			self.to_date.subscribe(function(newVal){
				self.to_date_format(new Date(newVal).format(Otime.dateFormat));
			});
			self.to_date(Otime.Date(data.to_date));

			self.user_hours	= Otime.o(data.hours || 0);
			self.tot_week_hours	= Otime.o("");

			var dt	= self.from_date(); // new Date();
			self._info.from_date	= Otime.o(dt.getWeekStart());
			self._info.cd_format	= Otime.o(new Date(self._info.current_date()).format(Otime.dateFormat));
			self._info.to_date	= Otime.o(dt.getWeekEnd());
			self._info.nth_week	= Otime.o(dt.getNthWeek());

			self._info.current_date.subscribe(function(newVal){
				newVal	= new Date(newVal);
				self._info.from_date(newVal.getWeekStart());
				self._info.to_date(newVal.getWeekEnd());
				self._info.cd_format(newVal.format(Otime.dateFormat));
//				var nth	= newVal.getNthWeek();
//				self._info.nth_week(nth + "<sup>" + (["st", "nd", "rd"][nth-1] || "th") + "</sup>");
				self._info.nth_week(newVal.getNthWeek());
				_this.appModel.loadTimeInfo();
			});

			self.timesheetdays	= Otime.o(data.days || 0);
			self.is_open		= Otime.o(false);

			self.days	= Otime.o({});
			self.items	= Otime.a([]);
		};

		_this.init	= function(){
			_this.list_container	= $("#tsa-container");

			Otime.unbind();

			_this.appModel	= new _this.TimesheetApproveModel();

			Otime.app.model	= _this.appModel;

			ko.applyBindings(_this.appModel, _this.list_container.get(0));

			_this.appModel.loadInfo();
		};



		_this.UserApprovedListModel	= function(data){
			var self	= this;
			data		= data || {};

			self.listing = Otime.a([]);
			if (typeof data.popup_close == "function")
			{
				self.popup_close	= data.popup_close;
			}
			self.project_id		= Otime.o(data.project_id || 0);
			self.billable		= Otime.o(data.billable || 0);
			self.project_name	= Otime.o(data.project_name || '');
			self.date_disp		= Otime.o(data.date_disp || '');
			self.from_date		= Otime.o(data.from_date || new Date());
			self.to_date		= Otime.o(data.to_date || new Date());


			self.check_all = Otime.o(false);
			
			self.check_all.subscribe(function(newValue){
				$.each(self.listing(), function(key, val){
					val.is_checked(newValue);
				});
			});

			self.update_billable = function(billable) {
				var billable = billable || false;
				var selected_data	= {};
				$.each(self.listing(), function(key, item){
					$.each(item.details, function(d_key, val){
						if (val.is_checked()==true) {
							selected_data[item.user_id] = selected_data[item.user_id] || [];
							selected_data[item.user_id].push(val.task_type_id);
						}
					});
				});

				var post_data = {};
				post_data.billable		= (!self.billable()) - 0;
				post_data.project_id	= self.project_id;
				post_data.users 	= selected_data;
				if (self.date_disp()!='ALL') {
					post_data.from_date	= new Date(self.from_date()).format(Otime.sdf);
					post_data.to_date	= new Date(self.to_date()).format(Otime.sdf);
				}

				Otime.app.postData(new Otime.ContextModel('update_billable', post_data, function(cont){
					self.refresh();
				}));
				
			}
			
			self.refresh	= function(){
				var data = {'project_id':self.project_id(), 'billable':self.billable()};
				if (self.date_disp()!='ALL') {
					data.from_date	= new Date(self.from_date()).format(Otime.sdf);
					data.to_date	= new Date(self.to_date()).format(Otime.sdf);
				}
				Otime.app.postData(new Otime.ContextModel('hours_details', data, function(cont){
					var response = cont.response;
					var _items	= {}, key="", task_types={};
					
					if (response.task_types && Object.keys(response.task_types).length > 0)
					{
						response.task_types	= response.task_types.otvalues.setKeys(response.task_types.otkeys, function(val){
							var key = val.task_type_id-0;
							task_types[key]	= val;
						});
					}
					
					if (response.items && Object.keys(response.items).length > 0)
					{
						response.items	= response.items.otvalues.setKeys(response.items.otkeys, function(item){
							key	= "user_id_" + item.user_id;
							_items[key]	= _items[key] || [];
							var ty_id = item.task_type_id-0;
							item.task_type	= task_types[ty_id]?task_types[ty_id].name:'-';
							_items[key].push(item);
						});
					}
					
					var tmpArr	= [];
					if (response.users && Object.keys(response.users).length > 0)
					{
						var key	= "";
						response.users	= response.users.otvalues.setKeys(response.users.otkeys, function(item){
							key	= "user_id_"+item.user_id;
							item.details	= _items[key] || [];
							item.user_name = $.trim((item.first_name || "") + " " + (item.last_name || "")).ucfirst();
							
							if (item.details.length > 0)
							{
								var hrs = 0;
								$.each(item.details, function(key, val){
										item.details[key].is_checked = Otime.o(false);
										hrs	+= (val.hours-0);
								});
								item.hours = hrs.toFixed(2);
								tmpArr.push(item);
							}

							item.is_checked = Otime.o(false);
							item.is_checked.subscribe(function(newValue){
								$.each(item.details, function(key, val){
										item.details[key].is_checked(newValue);
								});
							});
						});
					}
					
					self.listing(tmpArr);
					$("#approved_hours").modal('show');
				}));
			};

		};
	};
}(window.Otime));
